import * as React from 'react';
import * as enzyme from 'enzyme';
import Alert from '..';
var prefixCls = 'dk-alert';
describe('Alert[Basic]', function () {
  test("should render ." + prefixCls + " in a Alert", function () {
    var wrapper = enzyme.shallow(React.createElement(Alert, null, "A simple default alert\u2014check it out!"));
    wrapper.find(Alert).forEach(function (child) {
      expect(child.shallow().hasClass(prefixCls)).toBeTruthy();
    });
  });
});
describe('Alert[closable]', function () {
  test("should have close icon when set closable", function () {
    var wrapper = enzyme.shallow(React.createElement(Alert, {
      type: "info",
      closable: true
    }, "A simple info alert with close button!"));
    var eventMock = {
      preventDefault: jest.fn()
    };
    wrapper.find("." + prefixCls + "-close").simulate('click', eventMock);
    expect(wrapper.find(prefixCls).exists()).toBeFalsy();
  });
});