import * as React from 'react';
export declare type AlertType = 'default' | 'success' | 'error' | 'warning' | 'info' | 'loading';
export declare type AlertProps = {
    prefixCls?: string;
    className?: string;
    type?: AlertType;
    closable?: boolean;
    icon?: boolean;
    onClose?: VoidFunction;
    dismiss?: boolean;
};
export declare type AlertState = {
    dismiss: boolean;
};
declare class Alert extends React.PureComponent<AlertProps, AlertState> {
    static defaultProps: {
        prefixCls: string;
        type: import("../message/types").MessageType;
        closable: boolean;
        icon: boolean;
    };
    static getDerivedStateFromProps(nextProps: AlertProps): {
        dismiss: boolean;
    };
    constructor(props: AlertProps);
    render(): JSX.Element;
    private handleExited;
    private handleClose;
}
export default Alert;
