import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
import _assertThisInitialized from "@babel/runtime/helpers/esm/assertThisInitialized";
import _inheritsLoose from "@babel/runtime/helpers/esm/inheritsLoose";
import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";
import * as React from 'react';
import * as classNames from 'classnames';
import { CSSTransition } from 'react-transition-group';
import Icon from '../icon';

var Alert =
/*#__PURE__*/
function (_React$PureComponent) {
  _inheritsLoose(Alert, _React$PureComponent);

  Alert.getDerivedStateFromProps = function getDerivedStateFromProps(nextProps) {
    if ('dismiss' in nextProps) {
      return {
        dismiss: !!nextProps.dismiss
      };
    }

    return null;
  };

  function Alert(props) {
    var _this;

    _this = _React$PureComponent.call(this, props) || this;

    _defineProperty(_assertThisInitialized(_this), "handleExited", function () {
      var onClose = _this.props.onClose;

      if (typeof onClose === 'function') {
        onClose();
      }
    });

    _defineProperty(_assertThisInitialized(_this), "handleClose", function (e) {
      e.preventDefault();

      if (_this.state.dismiss) {
        return;
      }

      _this.setState({
        dismiss: true
      });
    });

    _this.state = {
      dismiss: false
    };
    return _this;
  }

  var _proto = Alert.prototype;

  _proto.render = function render() {
    var _classNames;

    var _this$props = this.props,
        prefixCls = _this$props.prefixCls,
        className = _this$props.className,
        children = _this$props.children,
        closable = _this$props.closable,
        icon = _this$props.icon,
        type = _this$props.type,
        dismissProp = _this$props.dismiss,
        attributes = _objectWithoutPropertiesLoose(_this$props, ["prefixCls", "className", "children", "closable", "icon", "type", "dismiss"]);

    var iconType = {
      success: 'check-circle',
      error: 'x-circle',
      warning: 'alert-circle',
      info: 'info'
    };
    var isShowIcon = icon && iconType[type];
    var alertClassName = classNames(prefixCls, (_classNames = {}, _classNames[prefixCls + "-" + type] = true, _classNames[prefixCls + "-with-close"] = closable, _classNames[prefixCls + "-with-icon"] = isShowIcon, _classNames), className);
    var dismiss = this.state.dismiss;
    return React.createElement(CSSTransition, {
      "in": !dismiss,
      timeout: 216,
      unmountOnExit: true,
      classNames: "" + prefixCls,
      onExited: this.handleExited
    }, React.createElement("div", _extends({
      className: alertClassName
    }, attributes), isShowIcon ? React.createElement("div", {
      className: prefixCls + "-icon-box"
    }, React.createElement(Icon, {
      type: iconType[type],
      className: prefixCls + "-icon"
    })) : null, children, closable ? React.createElement(Icon, {
      type: "x",
      className: prefixCls + "-close",
      onClick: this.handleClose
    }) : null));
  };

  return Alert;
}(React.PureComponent);

_defineProperty(Alert, "defaultProps", {
  prefixCls: 'dk-alert',
  type: 'default',
  closable: false,
  icon: false
});

export default Alert;