import * as React from 'react';
export declare type ButtonSize = 'small' | 'default' | 'large';
export declare type ButtonHtmlType = 'submit' | 'button' | 'reset';
export declare type ButtonType = 'default' | 'primary' | 'success' | 'danger' | 'warning' | 'info' | 'link';
export declare type ButtonProps = {
    prefixCls?: string;
    className?: string;
    size?: ButtonSize;
    type?: ButtonType;
    htmlType?: ButtonHtmlType;
    outline?: boolean;
    round?: boolean;
    disabled?: boolean;
    icon?: string;
    loading?: boolean;
    onClick?: React.MouseEventHandler<any>;
};
export declare type ButtonState = {
    spinning?: boolean;
};
declare class Button extends React.PureComponent<ButtonProps, ButtonState> {
    private static defaultProps;
    render(): JSX.Element;
}
export default Button;
