import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
import _inheritsLoose from "@babel/runtime/helpers/esm/inheritsLoose";
import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";
import * as classNames from 'classnames';
import * as React from 'react';
import Icon from '../icon';

var Button =
/*#__PURE__*/
function (_React$PureComponent) {
  _inheritsLoose(Button, _React$PureComponent);

  function Button() {
    return _React$PureComponent.apply(this, arguments) || this;
  }

  var _proto = Button.prototype;

  _proto.render = function render() {
    var _classNames, _classNames2, _classNames3;

    var _this$props = this.props,
        children = _this$props.children,
        prefixCls = _this$props.prefixCls,
        type = _this$props.type,
        outline = _this$props.outline,
        round = _this$props.round,
        size = _this$props.size,
        className = _this$props.className,
        disabled = _this$props.disabled,
        icon = _this$props.icon,
        loading = _this$props.loading,
        htmlType = _this$props.htmlType,
        attibutes = _objectWithoutPropertiesLoose(_this$props, ["children", "prefixCls", "type", "outline", "round", "size", "className", "disabled", "icon", "loading", "htmlType"]);

    var buttonClassName = classNames(prefixCls, (_classNames = {}, _classNames[prefixCls + "-" + type] = !outline, _classNames[prefixCls + "-large"] = size === 'large', _classNames[prefixCls + "-small"] = size === 'small', _classNames[prefixCls + "-outline-" + type] = outline, _classNames[prefixCls + "-rounded"] = round, _classNames[prefixCls + "-icon-only"] = icon && !children, _classNames), className);
    var iconNode = !!icon && React.createElement(Icon, {
      type: icon,
      className: classNames(prefixCls + "-icon", (_classNames2 = {}, _classNames2[prefixCls + "-icon-with-child"] = !!children, _classNames2))
    });
    var loadingNode = !!loading && React.createElement("div", {
      className: classNames(prefixCls + "-loading", (_classNames3 = {}, _classNames3[prefixCls + "-loading-default"] = type === 'default', _classNames3[prefixCls + "-loading-large"] = size === 'large', _classNames3[prefixCls + "-loading-small"] = size === 'small', _classNames3[prefixCls + "-loading-with-child"] = !!children, _classNames3))
    });
    return React.createElement("button", _extends({}, attibutes, {
      type: htmlType,
      className: buttonClassName,
      disabled: disabled || loading
    }), iconNode, loadingNode, children);
  };

  return Button;
}(React.PureComponent);

_defineProperty(Button, "defaultProps", {
  prefixCls: 'dk-btn',
  size: 'default',
  type: 'default',
  htmlType: 'button'
});

export default Button;