import * as React from 'react';
import { CalendarType, DateProps } from './typings';
export declare type CalendarProps = {
    prefixCls?: string;
    className?: string;
    disabled?: boolean;
    visible?: boolean;
    value?: any;
    format?: string;
    type: CalendarType;
    range?: boolean;
    min?: DateProps;
    max?: DateProps;
    placeholder?: string;
    onChange?: (date: Date | Date[], dateStr: string | string[]) => void;
};
export declare type CalendarState = {
    current: Date | Date[];
    visible?: boolean;
    value?: any;
    position: {
        top: number;
        left: number;
    };
    inputValue: string | string[];
};
declare class Calendar extends React.PureComponent<CalendarProps, CalendarState> {
    static componentType: string;
    static defaultProps: {
        prefixCls: string;
        type: string;
    };
    private readonly calendarElement;
    private readonly panelElement;
    static getDerivedStateFromProps(nextProps: CalendarProps): Partial<CalendarState>;
    constructor(props: CalendarProps);
    render(): JSX.Element;
    private renderContent;
    private getPosition;
    private handleEnter;
    private getPlaceholder;
    private getFormat;
    private getDateFromValue;
    private getCurrent;
    private handleInputFocus;
    private handleInputChange;
    private bindDocumentClick;
    private clearDocumentClick;
    private handleDocumentClick;
    private handleChange;
}
export default Calendar;
