import _extends from "@babel/runtime/helpers/esm/extends";
import _assertThisInitialized from "@babel/runtime/helpers/esm/assertThisInitialized";
import _inheritsLoose from "@babel/runtime/helpers/esm/inheritsLoose";
import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";
import * as React from 'react';
import Time from './time';
import Day from './day';
import Month from './month';
import Year from './year';

var Picker =
/*#__PURE__*/
function (_React$PureComponent) {
  _inheritsLoose(Picker, _React$PureComponent);

  function Picker(props) {
    var _this;

    _this = _React$PureComponent.call(this, props) || this;

    _defineProperty(_assertThisInitialized(_this), "handleModeChange", function (mode) {
      setTimeout(function () {
        _this.setState({
          mode: mode
        });
      }, 10);
    });

    var _mode;

    switch (props.type) {
      case 'week':
      case 'datetime':
        _mode = 'day';
        break;

      default:
        _mode = props.type;
        break;
    }

    _this.state = {
      mode: _mode
    };
    return _this;
  }

  var _proto = Picker.prototype;

  _proto.render = function render() {
    var mode = this.state.mode;
    var PickerChild;

    switch (mode) {
      case 'time':
        {
          PickerChild = Time;
          break;
        }

      case 'month':
        {
          PickerChild = Month;
          break;
        }

      case 'year':
        {
          PickerChild = Year;
          break;
        }

      default:
        {
          PickerChild = Day;
          break;
        }
    }

    return React.createElement(PickerChild, _extends({}, this.props, {
      onModeChange: this.handleModeChange
    }));
  };

  return Picker;
}(React.PureComponent);

export default Picker;