import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
import _assertThisInitialized from "@babel/runtime/helpers/esm/assertThisInitialized";
import _inheritsLoose from "@babel/runtime/helpers/esm/inheritsLoose";
import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";
import * as React from 'react';
import Picker from './picker';
import { compareAsc, isSameMonth, addMonths } from './utils';

var Range =
/*#__PURE__*/
function (_React$PureComponent) {
  _inheritsLoose(Range, _React$PureComponent);

  function Range(props) {
    var _this;

    _this = _React$PureComponent.call(this, props) || this;

    _defineProperty(_assertThisInitialized(_this), "firstSelectDate", void 0);

    _defineProperty(_assertThisInitialized(_this), "isSelectDate", void 0);

    _defineProperty(_assertThisInitialized(_this), "handleDayHover", function (date) {
      var rangeDate = _this.state.rangeDate;

      var _assertThisInitialize = _assertThisInitialized(_this),
          isSelectDate = _assertThisInitialize.isSelectDate,
          firstSelectDate = _assertThisInitialize.firstSelectDate;

      if (isSelectDate && firstSelectDate) {
        var diff = compareAsc(firstSelectDate, date);
        var newRangeDate = rangeDate;

        if (diff === -1) {
          newRangeDate = [firstSelectDate, date];
        } else if (diff === 1) {
          newRangeDate = [date, firstSelectDate];
        }

        _this.setState({
          rangeDate: newRangeDate
        });
      }
    });

    _defineProperty(_assertThisInitialized(_this), "handleChange", function (index, date, isSelectDay) {
      var rangeDate = _this.state.rangeDate;

      if (!isSelectDay) {
        var current = _this.props.current;
        current[index] = date;

        _this.props.onChange([].concat(current));

        return;
      }

      if (!_this.isSelectDate) {
        _this.firstSelectDate = date;
        _this.isSelectDate = true;

        _this.setState({
          rangeDate: [date]
        });
      } else if (_this.firstSelectDate) {
        _this.isSelectDate = false;
        var diff = compareAsc(_this.firstSelectDate, date);

        if (diff === 0) {
          _this.setState({
            rangeDate: undefined
          });

          _this.firstSelectDate = undefined;
          return;
        }

        var newRangeDate = rangeDate;

        if (diff === -1) {
          newRangeDate = [_this.firstSelectDate, date];
        } else {
          newRangeDate = [date, _this.firstSelectDate];
        }

        _this.setState({
          rangeDate: newRangeDate
        });

        _this.firstSelectDate = undefined;

        _this.props.onChange(newRangeDate, true);
      }
    });

    _this.state = {
      rangeDate: props.value
    };
    return _this;
  }

  var _proto = Range.prototype;

  _proto.render = function render() {
    var _this$props = this.props,
        current = _this$props.current,
        type = _this$props.type,
        value = _this$props.value,
        prefixCls = _this$props.prefixCls,
        attributes = _objectWithoutPropertiesLoose(_this$props, ["current", "type", "value", "prefixCls"]);

    var rangeDate = this.state.rangeDate;
    var newType = type === 'week' ? 'day' : type;
    var hideIcon = (newType === 'day' || newType === 'datetime') && isSameMonth(addMonths(current[0], 1), current[1]);
    return React.createElement(React.Fragment, null, React.createElement(Picker, _extends({}, attributes, {
      prefixCls: prefixCls,
      type: newType,
      current: current[0],
      rangeDate: rangeDate,
      hideRightIcon: hideIcon,
      onChange: this.handleChange.bind(this, 0),
      onDayHover: this.handleDayHover
    })), React.createElement(Picker, _extends({}, attributes, {
      prefixCls: prefixCls,
      type: newType,
      current: current[1],
      rangeDate: rangeDate,
      hideLeftIcon: hideIcon,
      onChange: this.handleChange.bind(this, 1),
      onDayHover: this.handleDayHover
    })));
  };

  return Range;
}(React.PureComponent);

export default Range;