import _assertThisInitialized from "@babel/runtime/helpers/esm/assertThisInitialized";
import _inheritsLoose from "@babel/runtime/helpers/esm/inheritsLoose";
import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";
import * as React from 'react';
import * as classNames from 'classnames';
import Scrollbar from '../scrollbar';
import { rangeNumber } from '../utils/number';
import { pad } from './utils';
var itemHeight = 32;

var Time =
/*#__PURE__*/
function (_React$PureComponent) {
  _inheritsLoose(Time, _React$PureComponent);

  function Time(props) {
    var _this;

    _this = _React$PureComponent.call(this, props) || this;

    _defineProperty(_assertThisInitialized(_this), "scrollRef", void 0);

    _defineProperty(_assertThisInitialized(_this), "handleItemClick", function (num) {
      var onChange = _this.props.onChange;
      var scrollbarElement = _this.scrollRef.current;

      if (scrollbarElement) {
        scrollbarElement.scrollTop(num * itemHeight, 120);
      }

      onChange(num);
    });

    _this.state = {
      autoHide: false
    };
    _this.scrollRef = React.createRef();
    return _this;
  }

  var _proto = Time.prototype;

  _proto.componentDidMount = function componentDidMount() {
    var _this2 = this;

    var value = this.props.value;
    var scrollbarElement = this.scrollRef.current;

    if (scrollbarElement) {
      setTimeout(function () {
        scrollbarElement.scrollTop(value * itemHeight);
        setTimeout(function () {
          _this2.setState({
            autoHide: true
          });
        }, 50);
      }, 0);
    }
  };

  _proto.render = function render() {
    var _this3 = this;

    var _this$props = this.props,
        prefixCls = _this$props.prefixCls,
        value = _this$props.value,
        _this$props$total = _this$props.total,
        total = _this$props$total === void 0 ? 0 : _this$props$total;
    return React.createElement(Scrollbar, {
      className: prefixCls + "-time-scroll",
      ref: this.scrollRef,
      autoHide: this.state.autoHide
    }, React.createElement("div", {
      className: prefixCls + "-time-list"
    }, rangeNumber(total, 0).map(function (num) {
      var _classNames;

      return React.createElement("span", {
        key: num,
        className: classNames((_classNames = {}, _classNames[prefixCls + "-time-item"] = true, _classNames[prefixCls + "-time-item-active"] = num === value, _classNames)),
        onClick: _this3.handleItemClick.bind(_this3, num)
      }, pad(num));
    })));
  };

  return Time;
}(React.PureComponent);

export default Time;