import _assertThisInitialized from "@babel/runtime/helpers/esm/assertThisInitialized";
import _inheritsLoose from "@babel/runtime/helpers/esm/inheritsLoose";
import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";
import * as React from 'react';
import * as classNames from 'classnames';
import { toDate } from './utils';
import TimeScroll from './time-scroll';

var Time =
/*#__PURE__*/
function (_React$PureComponent) {
  _inheritsLoose(Time, _React$PureComponent);

  Time.getDerivedStateFromProps = function getDerivedStateFromProps(nextProps, prevState) {
    if (nextProps.current.getTime() !== prevState.current.getTime()) {
      return {
        current: nextProps.type === 'time' ? prevState.current : nextProps.current
      };
    }

    return null;
  };

  function Time(props) {
    var _this;

    _this = _React$PureComponent.call(this, props) || this;

    _defineProperty(_assertThisInitialized(_this), "handleChange", function (mode, val) {
      var _this$props = _this.props,
          format = _this$props.format,
          type = _this$props.type,
          onChange = _this$props.onChange;
      var current = _this.state.current;
      var date = toDate(current);

      switch (mode) {
        case 'hour':
          if (format.indexOf('h') >= 0 && date.getHours() >= 12) {
            date.setHours(val + 12);
          } else {
            date.setHours(val);
          }

          break;

        case 'minute':
          date.setMinutes(val);
          break;

        case 'second':
          date.setSeconds(val);
          break;

        case 'ampm':
          var hours = date.getHours();

          if (val === 1 && hours < 12) {
            date.setHours(hours + 12);
          } else if (val === 0 && hours >= 12) {
            date.setHours(hours - 12);
          }

          break;

        default:
      }

      _this.setState({
        current: date
      });

      if (type === 'datetime') {
        onChange(date);
      }
    });

    _defineProperty(_assertThisInitialized(_this), "handleConfirm", function () {
      var onChange = _this.props.onChange;
      var current = _this.state.current;
      var date = toDate(current);
      onChange(date, true);
    });

    _defineProperty(_assertThisInitialized(_this), "handleCancel", function () {
      var _this$props2 = _this.props,
          current = _this$props2.current,
          onChange = _this$props2.onChange;

      _this.setState({
        current: current
      });

      onChange(current, true);
    });

    _this.state = {
      current: props.current
    };
    return _this;
  }

  var _proto = Time.prototype;

  _proto.render = function render() {
    var _this$props3 = this.props,
        type = _this$props3.type,
        format = _this$props3.format,
        className = _this$props3.className,
        prefixCls = _this$props3.prefixCls;
    var current = this.state.current;
    var date = toDate(current);
    var hours = format.indexOf('h') >= 0 && date.getHours() >= 12 ? date.getHours() - 12 : date.getHours();
    return React.createElement("div", {
      className: classNames(prefixCls + "-time", className)
    }, React.createElement("div", {
      className: prefixCls + "-time-container"
    }, format.indexOf('H') >= 0 && React.createElement(TimeScroll, {
      prefixCls: prefixCls,
      value: date.getHours(),
      total: 24,
      onChange: this.handleChange.bind(this, 'hour')
    }), format.indexOf('h') >= 0 && React.createElement(TimeScroll, {
      prefixCls: prefixCls,
      value: hours,
      total: 12,
      onChange: this.handleChange.bind(this, 'hour')
    }), format.indexOf('m') >= 0 && React.createElement(TimeScroll, {
      prefixCls: prefixCls,
      total: 60,
      value: date.getMinutes(),
      onChange: this.handleChange.bind(this, 'minute')
    }), format.indexOf('s') >= 0 && React.createElement(TimeScroll, {
      prefixCls: prefixCls,
      total: 60,
      value: date.getSeconds(),
      onChange: this.handleChange.bind(this, 'second')
    })), type !== 'datetime' ? React.createElement("div", {
      className: prefixCls + "-time-footer"
    }, React.createElement("div", {
      className: prefixCls + "-time-cancel",
      onClick: this.handleCancel
    }, "Cancel"), React.createElement("div", {
      className: prefixCls + "-time-confirm",
      onClick: this.handleConfirm
    }, "OK")) : null);
  };

  return Time;
}(React.PureComponent);

export default Time;