import _assertThisInitialized from "@babel/runtime/helpers/esm/assertThisInitialized";
import _inheritsLoose from "@babel/runtime/helpers/esm/inheritsLoose";
import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";
import * as React from 'react';
import * as classNames from 'classnames';
import { addYears, isSameYear } from './utils';
import { rangeNumber } from '../utils/number';
import Icon from '../icon';

var Year =
/*#__PURE__*/
function (_React$PureComponent) {
  _inheritsLoose(Year, _React$PureComponent);

  function Year(props) {
    var _this;

    _this = _React$PureComponent.call(this, props) || this;

    _defineProperty(_assertThisInitialized(_this), "handleYearClick", function (year) {
      var _this$props = _this.props,
          current = _this$props.current,
          onChange = _this$props.onChange,
          disabled = _this$props.disabled,
          type = _this$props.type,
          value = _this$props.value;

      if (disabled) {
        return;
      }

      var date = new Date(current.getTime());
      var isYear = type === 'year';
      date.setFullYear(year);
      onChange(date, isYear);

      if (!isYear) {
        _this.props.onModeChange('month');
      }
    });

    _defineProperty(_assertThisInitialized(_this), "handleYear", function (year) {
      var _this$props2 = _this.props,
          current = _this$props2.current,
          onChange = _this$props2.onChange,
          disabled = _this$props2.disabled;

      if (disabled) {
        return;
      }

      onChange(addYears(current, year));
    });

    _defineProperty(_assertThisInitialized(_this), "handlePrevRange", function () {
      _this.handleYear(-10);
    });

    _defineProperty(_assertThisInitialized(_this), "handleNextRange", function () {
      _this.handleYear(10);
    });

    return _this;
  }

  var _proto = Year.prototype;

  _proto.render = function render() {
    var _this2 = this;

    var _this$props3 = this.props,
        prefixCls = _this$props3.prefixCls,
        current = _this$props3.current,
        value = _this$props3.value,
        hideLeftIcon = _this$props3.hideLeftIcon,
        hideRightIcon = _this$props3.hideRightIcon;
    var startYear = Math.floor(current.getFullYear() / 10) * 10;
    var years = rangeNumber(11, -1).map(function (i) {
      return startYear + i;
    });
    return React.createElement("div", {
      className: prefixCls + "-ym"
    }, React.createElement("div", {
      className: prefixCls + "-header"
    }, React.createElement("div", {
      className: prefixCls + "-config"
    }, React.createElement(Icon, {
      className: prefixCls + "-config-icon",
      type: "chevrons-left",
      onClick: this.handlePrevRange,
      disabled: hideLeftIcon
    }), React.createElement("div", {
      className: prefixCls + "-select"
    }, React.createElement("span", null, years[1], " ~ ", years[years.length - 2])), React.createElement(Icon, {
      className: prefixCls + "-config-icon",
      type: "chevrons-right",
      onClick: this.handleNextRange,
      disabled: hideRightIcon
    }))), React.createElement("div", {
      className: prefixCls + "-list"
    }, years.map(function (year, i) {
      var _classNames;

      return React.createElement("div", {
        key: year,
        className: classNames((_classNames = {}, _classNames[prefixCls + "-ym-item"] = true, _classNames[prefixCls + "-ym-item-other"] = i === 0 || i === years.length - 1, _classNames[prefixCls + "-ym-item-active"] = value && isSameYear(year.toString(), value), _classNames)),
        onClick: _this2.handleYearClick.bind(_this2, year)
      }, React.createElement("span", null, year));
    })));
  };

  return Year;
}(React.PureComponent);

export default Year;