import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
import _assertThisInitialized from "@babel/runtime/helpers/esm/assertThisInitialized";
import _inheritsLoose from "@babel/runtime/helpers/esm/inheritsLoose";
import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";
import * as classNames from 'classnames';
import * as React from 'react';
import { CSSTransition } from 'react-transition-group';
import { createConsumer } from './context';

var Body =
/*#__PURE__*/
function (_React$PureComponent) {
  _inheritsLoose(Body, _React$PureComponent);

  function Body() {
    var _this;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _React$PureComponent.call.apply(_React$PureComponent, [this].concat(args)) || this;

    _defineProperty(_assertThisInitialized(_this), "handleEnter", function (el) {
      if (el.scrollHeight !== 0) {
        el.style.height = el.scrollHeight + 'px';
      }
    });

    _defineProperty(_assertThisInitialized(_this), "handleEntered", function (el) {
      el.style.height = '';
    });

    _defineProperty(_assertThisInitialized(_this), "handleExit", function (el) {
      el.style.height = el.scrollHeight + 'px';
    });

    _defineProperty(_assertThisInitialized(_this), "handleExiting", function (el) {
      if (el.scrollHeight !== 0) {
        el.style.height = '0';
      }
    });

    return _this;
  }

  var _proto = Body.prototype;

  _proto.render = function render() {
    var _classNames, _classNames2;

    var _this$props = this.props,
        className = _this$props.className,
        collapse = _this$props.collapse,
        handleHeaderClick = _this$props.handleHeaderClick,
        _this$props$prefixCls = _this$props.prefixCls,
        prefixCls = _this$props$prefixCls === void 0 ? 'dk-card' : _this$props$prefixCls,
        visible = _this$props.visible,
        attributes = _objectWithoutPropertiesLoose(_this$props, ["className", "collapse", "handleHeaderClick", "prefixCls", "visible"]);

    var basicClassName = classNames((_classNames = {}, _classNames[prefixCls + "-body"] = true, _classNames), className);
    var collapseClassName = classNames((_classNames2 = {}, _classNames2[prefixCls + "-body-collapse"] = true, _classNames2[prefixCls + "-body-collapse-visible"] = visible, _classNames2));
    var bodyNode = React.createElement("div", _extends({}, attributes, {
      className: basicClassName
    }));
    return collapse ? React.createElement(CSSTransition, {
      "in": visible,
      timeout: 350,
      onEnter: this.handleEnter,
      onEntered: this.handleEntered,
      onExit: this.handleExit,
      onExiting: this.handleExiting,
      classNames: prefixCls + "-body-collapse"
    }, React.createElement("div", {
      className: collapseClassName
    }, bodyNode)) : bodyNode;
  };

  return Body;
}(React.PureComponent);

export default createConsumer(Body);