import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
import _assertThisInitialized from "@babel/runtime/helpers/esm/assertThisInitialized";
import _inheritsLoose from "@babel/runtime/helpers/esm/inheritsLoose";
import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";
import * as classNames from 'classnames';
import * as React from 'react';
import { Provider } from './context';

var Card =
/*#__PURE__*/
function (_React$PureComponent) {
  _inheritsLoose(Card, _React$PureComponent);

  Card.getDerivedStateFromProps = function getDerivedStateFromProps(nextProps) {
    if ('visible' in nextProps) {
      return {
        visible: nextProps.visible
      };
    }

    return null;
  };

  function Card(props) {
    var _this;

    _this = _React$PureComponent.call(this, props) || this;

    _defineProperty(_assertThisInitialized(_this), "handleHeaderClick", function () {
      var visible = _this.state.visible;
      var _this$props = _this.props,
          index = _this$props.index,
          onCollapse = _this$props.onCollapse;

      if (typeof onCollapse === 'function') {
        onCollapse(index);
        return;
      }

      _this.setState({
        visible: !visible
      });
    });

    _this.state = {
      visible: !!props.visible
    };
    return _this;
  }

  var _proto = Card.prototype;

  _proto.render = function render() {
    var _this$props2 = this.props,
        className = _this$props2.className,
        prefixCls = _this$props2.prefixCls,
        children = _this$props2.children,
        collapse = _this$props2.collapse,
        visibleProp = _this$props2.visible,
        onCollapse = _this$props2.onCollapse,
        attributes = _objectWithoutPropertiesLoose(_this$props2, ["className", "prefixCls", "children", "collapse", "visible", "onCollapse"]);

    var visible = this.state.visible;
    var cardClassName = classNames(prefixCls, className);
    return React.createElement("div", _extends({}, attributes, {
      className: cardClassName
    }), React.createElement(Provider, {
      value: {
        visible: visible,
        collapse: collapse,
        handleHeaderClick: this.handleHeaderClick
      }
    }, children));
  };

  return Card;
}(React.PureComponent);

_defineProperty(Card, "Header", void 0);

_defineProperty(Card, "Footer", void 0);

_defineProperty(Card, "Body", void 0);

_defineProperty(Card, "Accordion", void 0);

_defineProperty(Card, "Collapse", void 0);

_defineProperty(Card, "defaultProps", {
  prefixCls: 'dk-card' // visible: true,

});

export default Card;