import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
import _assertThisInitialized from "@babel/runtime/helpers/esm/assertThisInitialized";
import _inheritsLoose from "@babel/runtime/helpers/esm/inheritsLoose";
import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";
import * as classNames from 'classnames';
import * as React from 'react';
import Card from './card';

var Collapse =
/*#__PURE__*/
function (_React$PureComponent) {
  _inheritsLoose(Collapse, _React$PureComponent);

  function Collapse(props) {
    var _this;

    _this = _React$PureComponent.call(this, props) || this;

    _defineProperty(_assertThisInitialized(_this), "handleCollapse", function (index) {
      var activeIndexs = _this.state.activeIndexs;
      var newActiveIndexs = activeIndexs.indexOf(index) === -1 ? Array.from(new Set([].concat(activeIndexs, [index]))) : activeIndexs.filter(function (i) {
        return i !== index;
      });

      _this.setState({
        activeIndexs: newActiveIndexs
      });
    });

    _this.state = {
      activeIndexs: props.activeIndexs || props.defaultActiveIndexs || []
    };
    return _this;
  }

  var _proto = Collapse.prototype;

  _proto.render = function render() {
    var _this2 = this;

    var _this$props = this.props,
        className = _this$props.className,
        children = _this$props.children,
        defaultActiveIndexs = _this$props.defaultActiveIndexs,
        activeIndexsProp = _this$props.activeIndexs,
        attributes = _objectWithoutPropertiesLoose(_this$props, ["className", "children", "defaultActiveIndexs", "activeIndexs"]);

    var collapseClassName = classNames('dk-card-collapse', className);
    var activeIndexs = this.state.activeIndexs;
    var newChildren = React.Children.map(children, function (child) {
      if (!child) {
        return null;
      }

      var index = child.props.index;

      var newProps = _extends({}, child.props, {
        collapse: true,
        visible: activeIndexs.indexOf(index) !== -1,
        onCollapse: _this2.handleCollapse.bind(_this2, index)
      });

      return React.createElement(Card, newProps);
    });
    return React.createElement("div", _extends({}, attributes, {
      className: collapseClassName
    }), newChildren);
  };

  return Collapse;
}(React.PureComponent);

export default Collapse;