import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
import _assertThisInitialized from "@babel/runtime/helpers/esm/assertThisInitialized";
import _inheritsLoose from "@babel/runtime/helpers/esm/inheritsLoose";
import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";
import * as React from 'react';
import * as classNames from 'classnames';
import { createConsumer } from './context';
import Icon from '../icon';

var Header =
/*#__PURE__*/
function (_React$PureComponent) {
  _inheritsLoose(Header, _React$PureComponent);

  function Header() {
    var _this;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _React$PureComponent.call.apply(_React$PureComponent, [this].concat(args)) || this;

    _defineProperty(_assertThisInitialized(_this), "handleClick", function () {
      var _this$props = _this.props,
          handleHeaderClick = _this$props.handleHeaderClick,
          onClick = _this$props.onClick,
          collapse = _this$props.collapse;

      if (collapse && typeof handleHeaderClick === 'function') {
        handleHeaderClick();
      }

      if (typeof onClick === 'function') {
        onClick();
      }
    });

    return _this;
  }

  var _proto = Header.prototype;

  _proto.render = function render() {
    var _classNames, _classNames2;

    var _this$props2 = this.props,
        className = _this$props2.className,
        prefixCls = _this$props2.prefixCls,
        children = _this$props2.children,
        title = _this$props2.title,
        handleHeaderClick = _this$props2.handleHeaderClick,
        collapse = _this$props2.collapse,
        visible = _this$props2.visible,
        attributes = _objectWithoutPropertiesLoose(_this$props2, ["className", "prefixCls", "children", "title", "handleHeaderClick", "collapse", "visible"]);

    var cardClassName = classNames((_classNames = {}, _classNames[prefixCls + "-header"] = true, _classNames[prefixCls + "-header-collapse"] = collapse, _classNames[prefixCls + "-header-collapse-visible"] = visible, _classNames), className);
    return React.createElement("div", _extends({}, attributes, {
      className: cardClassName,
      onClick: this.handleClick
    }), collapse ? React.createElement(Icon, {
      type: "chevron-right",
      className: classNames(prefixCls + "-header-icon", (_classNames2 = {}, _classNames2[prefixCls + "-header-icon-visible"] = visible, _classNames2))
    }) : null, children);
  };

  return Header;
}(React.PureComponent);

_defineProperty(Header, "defaultProps", {
  prefixCls: 'dk-card'
});

export default createConsumer(Header);