export declare type BasicProps = {
    className?: string;
    prefixCls?: string;
};
export declare type CardProps = BasicProps & {
    collapse?: boolean;
    index?: string | number;
    visible?: boolean;
    onCollapse?: (index: string | number) => void;
};
export declare type CardState = {
    visible: boolean;
};
export declare type ContextProps = BasicProps & {
    collapse?: boolean;
    handleHeaderClick?: (index?: string | number) => void;
    onClick: () => void;
    visible?: boolean;
};
export declare type HeaderProps = BasicProps & ContextProps & {
    title?: string;
};
export declare type BodyProps = BasicProps & ContextProps & {};
export declare type AccordionProps = BasicProps & {
    className?: string;
    prefixCls?: string;
};
export declare type CollapseProps = BasicProps & {
    defaultActiveIndexs?: Array<string | number>;
    activeIndexs?: Array<string | number>;
};
export declare type CollapseState = {
    activeIndexs: Array<string | number>;
};
