import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
import _assertThisInitialized from "@babel/runtime/helpers/esm/assertThisInitialized";
import _inheritsLoose from "@babel/runtime/helpers/esm/inheritsLoose";
import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";
import * as React from 'react';
import * as classNames from 'classnames';
import { createConsumer } from './context';

var Item =
/*#__PURE__*/
function (_React$Component) {
  _inheritsLoose(Item, _React$Component);

  function Item(props) {
    var _this;

    _this = _React$Component.call(this, props) || this;

    _defineProperty(_assertThisInitialized(_this), "getChecked", function () {
      var _this$props = _this.props,
          checked = _this$props.checked,
          value = _this$props.value;

      if (typeof checked === 'function') {
        return checked(value);
      }

      if (checked !== undefined) {
        return checked;
      }

      return _this.state.checked;
    });

    _defineProperty(_assertThisInitialized(_this), "handleChange", function (event) {
      var _this$props2 = _this.props,
          onChange = _this$props2.onChange,
          type = _this$props2.type,
          onRawChange = _this$props2.onRawChange,
          options = _this$props2.options,
          value = _this$props2.value;
      var checked = event.target.checked;

      if (type === 'checkbox' && options instanceof Array) {
        var _this$props3 = _this.props,
            min = _this$props3.min,
            max = _this$props3.max;
        var length = options.length + (checked ? 1 : -1);

        if (min !== undefined && length < min || max !== undefined && length > max) {
          return;
        }
      }

      if (onRawChange) {
        onRawChange(checked, value);
      }

      _this.setState({
        checked: checked
      });

      if (typeof onChange === 'function') {
        onChange(event);
      }
    });

    var _checked = 'defaultChecked' in props ? props.defaultChecked : !!props.checked;

    _this.state = {
      checked: _checked
    };
    return _this;
  }

  var _proto = Item.prototype;

  _proto.render = function render() {
    var _classNames;

    var _this$props4 = this.props,
        children = _this$props4.children,
        className = _this$props4.className,
        prefixCls = _this$props4.prefixCls,
        type = _this$props4.type,
        disabled = _this$props4.disabled,
        indeterminate = _this$props4.indeterminate,
        onChange = _this$props4.onChange,
        onRawChange = _this$props4.onRawChange,
        value = _this$props4.value,
        min = _this$props4.min,
        max = _this$props4.max,
        options = _this$props4.options,
        checked = _this$props4.checked,
        attributes = _objectWithoutPropertiesLoose(_this$props4, ["children", "className", "prefixCls", "type", "disabled", "indeterminate", "onChange", "onRawChange", "value", "min", "max", "options", "checked"]);

    var realChecked = this.getChecked();
    var checkboxClassName = classNames(prefixCls, (_classNames = {}, _classNames[prefixCls + "-checked"] = realChecked, _classNames[prefixCls + "-disabled"] = disabled, _classNames[prefixCls + "-group-item"] = typeof onRawChange === 'function', _classNames[prefixCls + "-indeterminate"] = indeterminate, _classNames), className);
    return React.createElement("label", _extends({
      className: checkboxClassName
    }, attributes), React.createElement("input", {
      className: prefixCls + "-input",
      type: type,
      disabled: disabled,
      onChange: this.handleChange,
      checked: realChecked,
      value: value
    }), React.createElement("i", {
      className: prefixCls + "-indicator"
    }), !!children && React.createElement("span", null, children));
  };

  return Item;
}(React.Component);

export default createConsumer(Item);