import * as React from 'react';
import * as enzyme from 'enzyme';
import Form from '..';
import Input from '../../input';
var prefixCls = 'dk-form';
it('calls onSubmit prop function when form is submitted', function () {
  var onSubmitFn = jest.fn();
  var wrapper = enzyme.mount(React.createElement(Form, {
    onSubmit: onSubmitFn
  }));
  var form = wrapper.find('form');
  form.simulate('submit');
  expect(onSubmitFn).toHaveBeenCalledTimes(1);
});
it('reads and sets input value', function () {
  var onSubmit = function onSubmit(event, values, errors) {
    expect(values.name).toEqual('Yuan Zhaohao');
    var isError = errors && errors.length;
    expect(isError).toBeTruthy();
  };

  var wrapper = enzyme.mount(React.createElement(Form, {
    onSubmit: onSubmit
  }, React.createElement(Form.Item, {
    label: "First Name",
    name: "name"
  }, React.createElement(Input, {
    name: "name"
  })), React.createElement(Form.Item, {
    label: "Email",
    name: "email",
    required: true
  }, React.createElement(Input, null))));
  wrapper.find('input[name="name"]').simulate('change', {
    target: {
      value: 'Yuan Zhaohao'
    }
  });
  wrapper.find('form').simulate('submit');
});