import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
import _extends from "@babel/runtime/helpers/esm/extends";
import _assertThisInitialized from "@babel/runtime/helpers/esm/assertThisInitialized";
import _inheritsLoose from "@babel/runtime/helpers/esm/inheritsLoose";
import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";
import * as classNames from 'classnames';
import * as React from 'react';
import { Provider } from './context';

var Form =
/*#__PURE__*/
function (_React$Component) {
  _inheritsLoose(Form, _React$Component);

  function Form(props) {
    var _this;

    _this = _React$Component.call(this, props) || this;

    _defineProperty(_assertThisInitialized(_this), "fields", void 0);

    _defineProperty(_assertThisInitialized(_this), "handleSubmit", function (event) {
      var onSubmit = _this.props.onSubmit;

      var values = _this.getFieldsValues();

      var errors = _this.getFiledsErrors();

      if (typeof onSubmit === 'function') {
        onSubmit(event, values, errors.length === 0 ? undefined : errors.filter(function (error) {
          return !!error;
        }), {
          reset: _this.reset
        });
      }
    });

    _defineProperty(_assertThisInitialized(_this), "handleReset", function (event) {
      var onReset = _this.props.onReset;

      _this.reset();

      if (typeof onReset === 'function') {
        onReset(event);
      }
    });

    _defineProperty(_assertThisInitialized(_this), "reset", function () {
      var _assertThisInitialize = _assertThisInitialized(_this),
          fields = _assertThisInitialize.fields;

      Object.keys(fields).forEach(function (key) {
        if (fields[key] && fields[key].component) {
          fields[key].component.resetField();
        }
      });
    });

    _defineProperty(_assertThisInitialized(_this), "addField", function (field) {
      _this.fields = _extends({}, _this.fields, field);
    });

    _defineProperty(_assertThisInitialized(_this), "removeField", function (name) {
      if (_this.fields[name]) {
        delete _this.fields[name];
      }
    });

    _defineProperty(_assertThisInitialized(_this), "getFields", function () {
      return _this.fields;
    });

    _defineProperty(_assertThisInitialized(_this), "getFieldsValues", function () {
      var _assertThisInitialize2 = _assertThisInitialized(_this),
          fields = _assertThisInitialize2.fields;

      var values = {};
      Object.keys(fields).forEach(function (key) {
        values[key] = fields[key].component.state.value;
      });
      return values;
    });

    _defineProperty(_assertThisInitialized(_this), "getFiledsErrors", function () {
      var _assertThisInitialize3 = _assertThisInitialized(_this),
          fields = _assertThisInitialize3.fields;

      var errors = [];
      Object.keys(fields).forEach(function (key) {
        var error = fields[key].component.checkInvalid();

        if (error && error.message) {
          errors.push(error);
        }
      });
      return errors;
    });

    _this.fields = {};
    return _this;
  }

  var _proto = Form.prototype;

  _proto.render = function render() {
    var _classNames;

    var _this$props = this.props,
        children = _this$props.children,
        prefixCls = _this$props.prefixCls,
        className = _this$props.className,
        onSubmit = _this$props.onSubmit,
        labelWidth = _this$props.labelWidth,
        labelAlign = _this$props.labelAlign,
        rules = _this$props.rules,
        attributes = _objectWithoutPropertiesLoose(_this$props, ["children", "prefixCls", "className", "onSubmit", "labelWidth", "labelAlign", "rules"]);

    var formClassName = classNames((_classNames = {}, _classNames["" + prefixCls] = true, _classNames), className);
    return React.createElement("form", _extends({}, attributes, {
      className: formClassName,
      onSubmit: this.handleSubmit,
      onReset: this.handleReset
    }), React.createElement(Provider, {
      value: {
        labelAlign: labelAlign,
        labelWidth: labelWidth,
        form: {
          rules: rules,
          getFieldsValues: this.getFieldsValues,
          getFields: this.getFields,
          addField: this.addField,
          removeField: this.removeField
        }
      }
    }, children));
  };

  return Form;
}(React.Component);

_defineProperty(Form, "Item", void 0);

_defineProperty(Form, "defaultProps", {
  prefixCls: 'dk-form',
  labelAlign: 'right'
});

export default Form;