import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
import _inheritsLoose from "@babel/runtime/helpers/esm/inheritsLoose";
import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";
import * as classNames from 'classnames';
import * as React from 'react';

function isInteger(value) {
  return typeof value === 'number' && isFinite(value) && Math.floor(value) === value;
}

var Col =
/*#__PURE__*/
function (_React$Component) {
  _inheritsLoose(Col, _React$Component);

  function Col() {
    return _React$Component.apply(this, arguments) || this;
  }

  var _proto = Col.prototype;

  _proto.render = function render() {
    var _classNames;

    var props = this.props;

    var _this$props = this.props,
        children = _this$props.children,
        prefixCls = _this$props.prefixCls,
        className = _this$props.className,
        first = _this$props.first,
        last = _this$props.last,
        attributes = _objectWithoutPropertiesLoose(_this$props, ["children", "prefixCls", "className", "first", "last"]);

    var classMap = {
      xs: prefixCls + "-col-xs",
      sm: prefixCls + "-col-sm",
      md: prefixCls + "-col-md",
      lg: prefixCls + "-col-lg",
      xl: prefixCls + "-col-xl",
      xsOffset: prefixCls + "-col-xs-offset",
      smOffset: prefixCls + "-col-sm-offset",
      mdOffset: prefixCls + "-col-md-offset",
      lgOffset: prefixCls + "-col-lg-offset",
      xlOffset: prefixCls + "-col-xl-offset"
    };
    var colKeysClassNames = Object.keys(attributes).filter(function (key) {
      return classMap[key];
    }).map(function (key) {
      delete attributes[key];

      if (isInteger(props[key])) {
        return classMap[key] + '-' + props[key];
      }

      return classMap[key];
    });
    var rowClassName = classNames(colKeysClassNames, (_classNames = {}, _classNames[prefixCls + "-first-" + first] = first !== undefined, _classNames[prefixCls + "-last-" + last] = last !== undefined, _classNames), className);
    return React.createElement("div", _extends({
      className: rowClassName
    }, attributes), children);
  };

  return Col;
}(React.Component);

_defineProperty(Col, "defaultProps", {
  prefixCls: 'dk-grid'
});

export default Col;