import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
import _assertThisInitialized from "@babel/runtime/helpers/esm/assertThisInitialized";
import _inheritsLoose from "@babel/runtime/helpers/esm/inheritsLoose";
import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";
import * as React from 'react';
import * as classNames from 'classnames';
var rowKeys = ['start', 'center', 'end', 'top', 'middle', 'bottom', 'around', 'between'];

var Row =
/*#__PURE__*/
function (_React$Component) {
  _inheritsLoose(Row, _React$Component);

  function Row() {
    var _this;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _React$Component.call.apply(_React$Component, [this].concat(args)) || this;

    _defineProperty(_assertThisInitialized(_this), "getRowClassNames", function () {
      var prefixCls = _this.props.prefixCls;
      return rowKeys.map(function (key) {
        var value = _this.props[key];

        if (!!value) {
          var _ref;

          return _ref = {}, _ref[prefixCls + "-" + key + "-" + value] = true, _ref;
        }

        return null;
      });
    });

    return _this;
  }

  var _proto = Row.prototype;

  _proto.render = function render() {
    var _classNames;

    var _this$props = this.props,
        children = _this$props.children,
        prefixCls = _this$props.prefixCls,
        className = _this$props.className,
        reverse = _this$props.reverse,
        attributes = _objectWithoutPropertiesLoose(_this$props, ["children", "prefixCls", "className", "reverse"]);

    var rowKeysClassNames = this.getRowClassNames();
    var rowClassName = classNames(prefixCls + "-row", rowKeysClassNames, (_classNames = {}, _classNames[prefixCls + "-row-reverse"] = reverse, _classNames), className);
    rowKeys.forEach(function (key) {
      delete attributes[key];
    });
    return React.createElement("div", _extends({
      className: rowClassName
    }, attributes), children);
  };

  return Row;
}(React.Component);

_defineProperty(Row, "defaultProps", {
  prefixCls: 'dk-grid',
  reverse: false
});

export default Row;