import * as React from 'react';
export declare type InputSize = 'small' | 'default' | 'large';
export declare type InputFormStatus = 'error' | 'default' | 'success' | 'warning';
export declare type InputProps = {
    className?: string;
    prefixCls?: string;
    size?: InputSize;
    name?: string;
    disabled?: boolean;
    value?: string;
    defaultValue?: string;
    placeholder?: string;
    status?: InputFormStatus;
    type?: 'text' | 'password' | 'number';
    digits?: number;
    prefix?: string;
    prefixClassName?: string;
    suffix?: string;
    suffixClassName?: string;
    wrapperProps?: any;
    wrapperRef?: React.RefObject<HTMLDivElement>;
    onChange?: (value: string) => void;
    onBlur?: (event: React.ChangeEvent<HTMLInputElement>) => void;
    onFocus?: (event: React.ChangeEvent<HTMLInputElement>) => void;
};
declare class Input extends React.Component<InputProps> {
    static componentType: string;
    static defaultProps: {
        prefixCls: string;
        size: import("../select/typings").SelectSize;
        status: import("../form/typings").FormItemStatus;
        type: string;
    };
    static getDerivedStateFromProps(nextProps: InputProps): {
        value: string;
    };
    constructor(props: InputProps);
    render(): JSX.Element;
    handleChange: (event: React.ChangeEvent<HTMLInputElement>) => void;
    handleBlur: (event: React.ChangeEvent<HTMLInputElement>) => void;
    handleFocus: (event: React.ChangeEvent<HTMLInputElement>) => void;
    invalidNumber: (value: string) => boolean;
}
export default Input;
