import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
import _assertThisInitialized from "@babel/runtime/helpers/esm/assertThisInitialized";
import _inheritsLoose from "@babel/runtime/helpers/esm/inheritsLoose";
import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";
import * as React from 'react';
import * as classNames from 'classnames';
import Sidebar from './sidebar';
import { LayoutProvider } from './context';

var Layout =
/*#__PURE__*/
function (_React$Component) {
  _inheritsLoose(Layout, _React$Component);

  function Layout() {
    var _this;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _React$Component.call.apply(_React$Component, [this].concat(args)) || this;

    _defineProperty(_assertThisInitialized(_this), "state", {
      sidebars: []
    });

    return _this;
  }

  var _proto = Layout.prototype;

  _proto.render = function render() {
    var _classNames;

    var _this$props = this.props,
        prefixCls = _this$props.prefixCls,
        className = _this$props.className,
        children = _this$props.children,
        hasSidebar = _this$props.hasSidebar,
        attibutes = _objectWithoutPropertiesLoose(_this$props, ["prefixCls", "className", "children", "hasSidebar"]);

    var layoutClassName = classNames((_classNames = {}, _classNames["" + prefixCls] = true, _classNames[prefixCls + "-has-sidebar"] = hasSidebar || this.state.sidebars.length > 0, _classNames), className);
    return React.createElement("div", _extends({
      className: layoutClassName
    }, attibutes), React.createElement(LayoutProvider, {
      value: this.getLayoutContext()
    }, children));
  };

  _proto.getLayoutContext = function getLayoutContext() {
    var _this2 = this;

    return {
      addSidebar: function addSidebar(id) {
        _this2.setState({
          sidebars: [].concat(_this2.state.sidebars, [id])
        });
      },
      removeSidebar: function removeSidebar(id) {
        _this2.setState({
          sidebars: _this2.state.sidebars.filter(function (currentId) {
            return currentId !== id;
          })
        });
      }
    };
  };

  return Layout;
}(React.Component);

_defineProperty(Layout, "Header", void 0);

_defineProperty(Layout, "Footer", void 0);

_defineProperty(Layout, "Content", void 0);

_defineProperty(Layout, "Sidebar", void 0);

_defineProperty(Layout, "defaultProps", {
  prefixCls: 'dk-layout',
  hasSidebar: false
});

function generator(cls) {
  var _class, _temp;

  return _temp = _class =
  /*#__PURE__*/
  function (_React$Component2) {
    _inheritsLoose(Basic, _React$Component2);

    function Basic() {
      return _React$Component2.apply(this, arguments) || this;
    }

    var _proto2 = Basic.prototype;

    _proto2.render = function render() {
      var _this$props2 = this.props,
          prefixCls = _this$props2.prefixCls,
          className = _this$props2.className,
          children = _this$props2.children,
          attibutes = _objectWithoutPropertiesLoose(_this$props2, ["prefixCls", "className", "children"]);

      var basicClassName = classNames(prefixCls + "-" + cls, className);
      return React.createElement("div", _extends({
        className: basicClassName
      }, attibutes), children);
    };

    return Basic;
  }(React.Component), _defineProperty(_class, "defaultProps", {
    prefixCls: 'dk-layout'
  }), _temp;
}

var Header = generator('header');
var Footer = generator('footer');
var Content = generator('content');
Layout.Header = Header;
Layout.Footer = Footer;
Layout.Content = Content;
Layout.Sidebar = Sidebar;
export default Layout;