import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
import _assertThisInitialized from "@babel/runtime/helpers/esm/assertThisInitialized";
import _inheritsLoose from "@babel/runtime/helpers/esm/inheritsLoose";
import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";
import * as React from 'react';
import * as classNames from 'classnames';
import { createConsumer } from './context';

var generateId = function () {
  var i = 0;
  return function (prefix) {
    if (prefix === void 0) {
      prefix = '';
    }

    i += 1;
    return "" + prefix + i;
  };
}();

var Sidebar =
/*#__PURE__*/
function (_React$Component) {
  _inheritsLoose(Sidebar, _React$Component);

  function Sidebar(props) {
    var _this;

    _this = _React$Component.call(this, props) || this;

    _defineProperty(_assertThisInitialized(_this), "uniqueId", void 0);

    _this.uniqueId = generateId('dashkit-sidebar-');
    return _this;
  }

  var _proto = Sidebar.prototype;

  _proto.componentDidMount = function componentDidMount() {
    if (this.props.addSidebar) {
      this.props.addSidebar(this.uniqueId);
    }
  };

  _proto.componentWillUnmount = function componentWillUnmount() {
    if (this.props.removeSidebar) {
      this.props.removeSidebar(this.uniqueId);
    }
  };

  _proto.render = function render() {
    var _this$props = this.props,
        className = _this$props.className,
        children = _this$props.children,
        addSidebar = _this$props.addSidebar,
        removeSidebar = _this$props.removeSidebar,
        attributes = _objectWithoutPropertiesLoose(_this$props, ["className", "children", "addSidebar", "removeSidebar"]);

    var layoutClassName = classNames('dk-layout-sidebar', className);
    return React.createElement("div", _extends({}, attributes, {
      className: layoutClassName
    }), children);
  };

  return Sidebar;
}(React.Component);

export default createConsumer(Sidebar);