import * as React from 'react';
import MenuItem from './item';
import ItemGroup from './item-group';
import SubMenu from './sub-menu';
import { MenuProps, MenuState } from './typings';
declare class Menu extends React.Component<Partial<MenuProps>, MenuState> {
    static Item: typeof MenuItem;
    static ItemGroup: typeof ItemGroup;
    static SubMenu: typeof SubMenu;
    static defaultProps: {
        prefixCls: string;
        mode: string;
        theme: string;
    };
    static getDerivedStateFromProps(nextProps: MenuProps): {
        activeIndex: string;
    };
    constructor(props: MenuProps);
    render(): JSX.Element;
    getMenuContext(): {
        getState: () => Readonly<MenuState>;
        getProps: () => Readonly<{
            children?: React.ReactNode;
        }> & Readonly<Partial<MenuProps>>;
        selectItem: (index: string) => void;
        addOpenedMenu: (index: string) => void;
        removeOpenedMenu: (index: string) => void;
        existOpenedMenu: (index: string) => boolean;
    };
}
export default Menu;
