import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
import * as React from 'react';
import * as classNames from 'classnames';

var MenuItemGroup = function MenuItemGroup(props) {
  var children = props.children,
      _props$prefixCls = props.prefixCls,
      prefixCls = _props$prefixCls === void 0 ? 'dk-menu' : _props$prefixCls,
      className = props.className,
      title = props.title,
      attributes = _objectWithoutPropertiesLoose(props, ["children", "prefixCls", "className", "title"]);

  var groupClassName = classNames(prefixCls + "-item-group", className);
  return React.createElement(React.Fragment, null, React.createElement("li", _extends({
    className: groupClassName
  }, attributes), title), children);
};

export default MenuItemGroup;