import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
import _assertThisInitialized from "@babel/runtime/helpers/esm/assertThisInitialized";
import _inheritsLoose from "@babel/runtime/helpers/esm/inheritsLoose";
import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";
import * as React from 'react';
import * as classNames from 'classnames';
import { createConsumer } from './context';
import Icon from '../icon';

var MenuItem =
/*#__PURE__*/
function (_React$Component) {
  _inheritsLoose(MenuItem, _React$Component);

  function MenuItem() {
    var _this;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _React$Component.call.apply(_React$Component, [this].concat(args)) || this;

    _defineProperty(_assertThisInitialized(_this), "handleClick", function (e) {
      e.preventDefault();
      e.stopPropagation();
      var _this$props = _this.props,
          rootContext = _this$props.rootContext,
          index = _this$props.index;
      rootContext.selectItem(index);
    });

    return _this;
  }

  var _proto = MenuItem.prototype;

  _proto.render = function render() {
    var _classNames;

    var _this$props2 = this.props,
        children = _this$props2.children,
        prefixCls = _this$props2.prefixCls,
        className = _this$props2.className,
        index = _this$props2.index,
        disabled = _this$props2.disabled,
        rootContext = _this$props2.rootContext,
        icon = _this$props2.icon,
        attributes = _objectWithoutPropertiesLoose(_this$props2, ["children", "prefixCls", "className", "index", "disabled", "rootContext", "icon"]);

    var rootState = rootContext.getState();
    var isHorizontal = rootContext.getProps().mode === 'horizontal';
    var itemClassName = classNames((_classNames = {}, _classNames[prefixCls + "-item"] = true, _classNames[prefixCls + "-horizontal-item"] = isHorizontal, _classNames[prefixCls + "-item-active"] = rootState.activeIndex === index, _classNames[prefixCls + "-item-disabled"] = disabled, _classNames), className);
    var iconNode = icon && typeof icon === 'string' ? React.createElement(Icon, {
      type: icon,
      className: prefixCls + "-icon"
    }) : null;
    return React.createElement("li", _extends({
      className: itemClassName,
      onClick: disabled ? undefined : this.handleClick
    }, attributes), iconNode, children);
  };

  return MenuItem;
}(React.Component);

_defineProperty(MenuItem, "defaultProps", {
  prefixCls: 'dk-menu',
  disabled: false
});

export default createConsumer(MenuItem);