import _assertThisInitialized from "@babel/runtime/helpers/esm/assertThisInitialized";
import _inheritsLoose from "@babel/runtime/helpers/esm/inheritsLoose";
import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";
import * as React from 'react';
import Alert from '../alert';

var MessageItem =
/*#__PURE__*/
function (_React$PureComponent) {
  _inheritsLoose(MessageItem, _React$PureComponent);

  function MessageItem(props) {
    var _this;

    _this = _React$PureComponent.call(this, props) || this;

    _defineProperty(_assertThisInitialized(_this), "closeTimer", void 0);

    _defineProperty(_assertThisInitialized(_this), "close", function () {
      _this.clearCloseTimer();

      _this.setState({
        dismiss: true
      });

      setTimeout(function () {
        if (typeof _this.props.onClose === 'function') {
          _this.props.onClose();
        }
      }, 0);
    });

    _defineProperty(_assertThisInitialized(_this), "startCloseTimer", function () {
      if (_this.props.duration) {
        _this.closeTimer = window.setTimeout(function () {
          _this.close();
        }, _this.props.duration * 1000);
      }
    });

    _defineProperty(_assertThisInitialized(_this), "clearCloseTimer", function () {
      if (_this.closeTimer) {
        clearTimeout(_this.closeTimer);
        _this.closeTimer = 0;
      }
    });

    _defineProperty(_assertThisInitialized(_this), "destory", function () {
      _this.setState({
        closed: true
      });
    });

    _this.closeTimer = 0;
    _this.state = {
      dismiss: false,
      closed: false
    };
    return _this;
  }

  var _proto = MessageItem.prototype;

  _proto.componentDidMount = function componentDidMount() {
    this.startCloseTimer();
  };

  _proto.componentDidUpdate = function componentDidUpdate(prevProps) {
    if (this.props.duration !== prevProps.duration) {
      this.restartCloseTimer();
    }
  };

  _proto.componentWillUnmount = function componentWillUnmount() {
    this.clearCloseTimer();
  };

  _proto.restartCloseTimer = function restartCloseTimer() {
    this.clearCloseTimer();
    this.startCloseTimer();
  };

  _proto.render = function render() {
    var _this$props = this.props,
        prefixCls = _this$props.prefixCls,
        type = _this$props.type,
        content = _this$props.content;
    var _this$state = this.state,
        dismiss = _this$state.dismiss,
        closed = _this$state.closed;
    return closed ? null : React.createElement("div", {
      className: prefixCls + "-item",
      onMouseEnter: this.clearCloseTimer,
      onMouseLeave: this.startCloseTimer
    }, React.createElement(Alert, {
      className: prefixCls + "-content",
      onClose: this.destory,
      dismiss: dismiss,
      type: type,
      icon: true
    }, content));
  };

  return MessageItem;
}(React.PureComponent);

export default MessageItem;