import _assertThisInitialized from "@babel/runtime/helpers/esm/assertThisInitialized";
import _inheritsLoose from "@babel/runtime/helpers/esm/inheritsLoose";
import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";
import * as React from 'react';
import { TransitionGroup } from 'react-transition-group';
import MessageItem from './item';

var Message =
/*#__PURE__*/
function (_React$PureComponent) {
  _inheritsLoose(Message, _React$PureComponent);

  function Message(props) {
    var _this;

    _this = _React$PureComponent.call(this, props) || this;

    _defineProperty(_assertThisInitialized(_this), "addMessage", function (message) {
      var max = _this.props.max;
      var messages = _this.state.messages;
      var tempMessages = [].concat(messages, [message]);

      if (tempMessages.length > max) {
        tempMessages.unshift();
      }

      _this.setState({
        messages: tempMessages
      });
    });

    _defineProperty(_assertThisInitialized(_this), "removeMessage", function (id) {
      var _this$props = _this.props,
          transitionDuration = _this$props.transitionDuration,
          onDestory = _this$props.onDestory;
      var messages = _this.state.messages;
      var tempMessages = messages.filter(function (message) {
        return message.id !== id;
      });

      _this.setState({
        messages: tempMessages
      }); // if (tempMessages.length === 0) {
      //   setTimeout(() => {
      //     if (typeof onDestory === 'function') {
      //       if (window.requestAnimationFrame) {
      //         window.requestAnimationFrame(() => {
      //           onDestory();
      //         });
      //       } else {
      //         onDestory();
      //       }
      //     }
      //   }, transitionDuration * 1000);
      // }

    });

    _this.state = {
      messages: []
    };
    return _this;
  }

  var _proto = Message.prototype;

  _proto.render = function render() {
    var _this2 = this;

    var prefixCls = this.props.prefixCls;
    var messages = this.state.messages;
    return React.createElement(TransitionGroup, {
      className: prefixCls
    }, messages && messages.length ? messages.map(function (_ref) {
      var id = _ref.id,
          type = _ref.type,
          content = _ref.content,
          duration = _ref.duration,
          _onClose = _ref.onClose;
      return React.createElement(MessageItem, {
        key: id,
        type: type,
        content: content,
        prefixCls: prefixCls,
        duration: duration,
        onClose: function onClose() {
          _this2.removeMessage(id);

          if (typeof _onClose === 'function') {
            _onClose();
          }
        }
      });
    }) : null);
  };

  return Message;
}(React.PureComponent);

export default Message;