import _assertThisInitialized from "@babel/runtime/helpers/esm/assertThisInitialized";
import _inheritsLoose from "@babel/runtime/helpers/esm/inheritsLoose";
import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";
import * as React from 'react';
import * as classNames from 'classnames';
import { CSSTransition } from 'react-transition-group';
import Icon from '../icon';
import Button from '../button';
var ESC_KEY = 27;

var ModalPanel =
/*#__PURE__*/
function (_React$Component) {
  _inheritsLoose(ModalPanel, _React$Component);

  function ModalPanel(props) {
    var _this;

    _this = _React$Component.call(this, props) || this;

    _defineProperty(_assertThisInitialized(_this), "bodyRef", void 0);

    _defineProperty(_assertThisInitialized(_this), "openModal", function () {
      _this.setState({
        visible: true
      }, function () {
        _this.setState({
          bodyVisible: true
        });
      });
    });

    _defineProperty(_assertThisInitialized(_this), "closeModal", function () {
      _this.setState({
        bodyVisible: false
      });
    });

    _defineProperty(_assertThisInitialized(_this), "handleClose", function () {
      _this.closeModal();
    });

    _defineProperty(_assertThisInitialized(_this), "handleExited", function () {
      var onClose = _this.props.onClose;

      _this.setState({
        visible: false
      });

      if (typeof onClose === 'function') {
        onClose();
      }
    });

    _defineProperty(_assertThisInitialized(_this), "focusBody", function () {
      var bodyElement = _this.bodyRef.current;

      if (bodyElement) {
        bodyElement.focus();
      }
    });

    _defineProperty(_assertThisInitialized(_this), "handleKeydown", function (event) {
      if (event.keyCode === ESC_KEY) {
        event.stopPropagation();

        _this.closeModal();
      }
    });

    _this.state = {
      visible: false,
      bodyVisible: false
    };
    _this.bodyRef = React.createRef();
    return _this;
  }

  var _proto = ModalPanel.prototype;

  _proto.componentDidUpdate = function componentDidUpdate(prevProps, prevState) {
    var _this2 = this;

    if (this.props.visible && !prevProps.visible) {
      this.openModal();
    } else if (!this.props.visible && prevProps.visible) {
      this.closeModal();
    }

    if (this.state.visible && !prevState.visible) {
      setTimeout(function () {
        _this2.focusBody();
      }, 0);
    }
  };

  _proto.render = function render() {
    if (!this.state.visible) {
      return null;
    }

    var _this$props = this.props,
        prefixCls = _this$props.prefixCls,
        showFooter = _this$props.showFooter,
        footer = _this$props.footer,
        closeByEsc = _this$props.closeByEsc,
        title = _this$props.title,
        className = _this$props.className,
        width = _this$props.width,
        children = _this$props.children;
    var footerNode = React.createElement(React.Fragment, null, React.createElement(Button, {
      type: "default",
      onClick: this.props.onCancel
    }, "Cancel"), React.createElement(Button, {
      type: "primary",
      className: prefixCls + "-footer-confirm",
      onClick: this.props.onConfirm
    }, "OK"));
    var bodyNode = React.createElement(CSSTransition, {
      "in": this.state.bodyVisible,
      unmountOnExit: true,
      timeout: 300,
      classNames: prefixCls + "-panel",
      onExited: this.handleExited
    }, React.createElement("div", {
      className: classNames(prefixCls + "-panel", className),
      onKeyDown: closeByEsc ? this.handleKeydown : undefined,
      tabIndex: -1,
      ref: this.bodyRef,
      style: width !== undefined ? {
        width: width
      } : null
    }, !!title && React.createElement(React.Fragment, null, React.createElement("div", {
      className: prefixCls + "-header"
    }, title), React.createElement("div", {
      className: prefixCls + "-close",
      onClick: this.handleClose
    }, React.createElement(Icon, {
      className: prefixCls + "-close-icon",
      type: "x"
    }))), React.createElement("div", {
      className: prefixCls + "-body"
    }, children), !!showFooter && React.createElement("div", {
      className: prefixCls + "-footer"
    }, footer === undefined ? footerNode : footer)));
    return React.createElement("div", {
      className: "" + prefixCls
    }, React.createElement(CSSTransition, {
      timeout: 300,
      "in": this.state.bodyVisible,
      classNames: prefixCls + "-mask"
    }, React.createElement("div", {
      className: prefixCls + "-mask",
      onClick: this.handleClose
    })), bodyNode);
  };

  return ModalPanel;
}(React.Component);

_defineProperty(ModalPanel, "defaultProps", {
  prefixCls: 'dk-modal',
  closeByEsc: true,
  showFooter: true
});

_defineProperty(ModalPanel, "success", void 0);

export default ModalPanel;