import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
import * as React from 'react';
import Tooltip from '../tooltip';

var Popover = function Popover(props) {
  var content = props.content,
      _props$prefixCls = props.prefixCls,
      prefixCls = _props$prefixCls === void 0 ? 'dk-popover' : _props$prefixCls,
      trigger = props.trigger,
      title = props.title,
      visible = props.visible,
      attibutes = _objectWithoutPropertiesLoose(props, ["content", "prefixCls", "trigger", "title", "visible"]);

  var realContent = React.createElement(React.Fragment, null, React.createElement("div", {
    className: prefixCls + "-title"
  }, title), React.createElement("div", {
    className: prefixCls + "-content"
  }, content));
  return React.createElement(Tooltip, _extends({}, attibutes, {
    trigger: trigger,
    prefixCls: prefixCls,
    content: realContent
  }));
};

export default Popover;