import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
import _assertThisInitialized from "@babel/runtime/helpers/esm/assertThisInitialized";
import _inheritsLoose from "@babel/runtime/helpers/esm/inheritsLoose";
import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";
import * as React from 'react';
import * as classNames from 'classnames';
import { isEqual } from 'lodash-es';
import { Provider as RadioProvider } from '../checkbox/context';

var RadioGroup =
/*#__PURE__*/
function (_React$PureComponent) {
  _inheritsLoose(RadioGroup, _React$PureComponent);

  RadioGroup.getDerivedStateFromProps = function getDerivedStateFromProps(nextProps, prevState) {
    if (!isEqual(nextProps.value, prevState.value)) {
      return {
        value: nextProps.value
      };
    }

    return null;
  };

  function RadioGroup(props) {
    var _this;

    _this = _React$PureComponent.call(this, props) || this;

    _defineProperty(_assertThisInitialized(_this), "handleRawChange", function (checked, value) {
      var onChange = _this.props.onChange;

      _this.setState({
        value: value
      });

      if (typeof onChange === 'function') {
        onChange(value);
      }
    });

    _defineProperty(_assertThisInitialized(_this), "handleChecked", function (value) {
      return value === _this.state.value;
    });

    var _value = props.defaultValue || props.value;

    _this.state = {
      value: _value
    };
    return _this;
  }

  var _proto = RadioGroup.prototype;

  _proto.render = function render() {
    var _classNames;

    var _this$props = this.props,
        className = _this$props.className,
        prefixCls = _this$props.prefixCls,
        children = _this$props.children,
        onChange = _this$props.onChange,
        value = _this$props.value,
        defaultValue = _this$props.defaultValue,
        attibutes = _objectWithoutPropertiesLoose(_this$props, ["className", "prefixCls", "children", "onChange", "value", "defaultValue"]);

    var groupClassName = classNames((_classNames = {}, _classNames[prefixCls + "-group"] = true, _classNames), className);
    return React.createElement("div", _extends({
      className: groupClassName
    }, attibutes), React.createElement(RadioProvider, {
      value: {
        onRawChange: this.handleRawChange,
        checked: this.handleChecked
      }
    }, children));
  };

  return RadioGroup;
}(React.PureComponent);

_defineProperty(RadioGroup, "componentType", 'RadioGroup');

_defineProperty(RadioGroup, "defaultProps", {
  prefixCls: 'dk-radio'
});

export default RadioGroup;