import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
import * as React from 'react';
import * as classNames from 'classnames';

var OptionGroup = function OptionGroup(props) {
  var _classNames;

  var _props$prefixCls = props.prefixCls,
      prefixCls = _props$prefixCls === void 0 ? 'dk-select' : _props$prefixCls,
      className = props.className,
      label = props.label,
      children = props.children,
      attributes = _objectWithoutPropertiesLoose(props, ["prefixCls", "className", "label", "children"]);

  var groupClassName = classNames((_classNames = {}, _classNames[prefixCls + "-group"] = true, _classNames), className);
  return React.createElement("div", _extends({
    className: groupClassName
  }, attributes), React.createElement("div", {
    className: prefixCls + "-group-title"
  }, label), React.createElement("div", {
    className: prefixCls + "-group-list"
  }, children));
};

export default OptionGroup;