import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
import _assertThisInitialized from "@babel/runtime/helpers/esm/assertThisInitialized";
import _inheritsLoose from "@babel/runtime/helpers/esm/inheritsLoose";
import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";
import * as React from 'react';
import * as classNames from 'classnames';
import { createConsumer } from './context';

var Option =
/*#__PURE__*/
function (_React$PureComponent) {
  _inheritsLoose(Option, _React$PureComponent);

  function Option() {
    var _this;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _React$PureComponent.call.apply(_React$PureComponent, [this].concat(args)) || this;

    _defineProperty(_assertThisInitialized(_this), "handleOptionClick", function () {
      var _this$props = _this.props,
          value = _this$props.value,
          disabled = _this$props.disabled,
          onRawChange = _this$props.onRawChange;

      if (!disabled && typeof onRawChange === 'function') {
        onRawChange(value);
      }
    });

    return _this;
  }

  var _proto = Option.prototype;

  _proto.render = function render() {
    var _classNames;

    var _this$props2 = this.props,
        prefixCls = _this$props2.prefixCls,
        value = _this$props2.value,
        className = _this$props2.className,
        inputValue = _this$props2.inputValue,
        onRawChange = _this$props2.onRawChange,
        disabled = _this$props2.disabled,
        options = _this$props2.options,
        filterOption = _this$props2.filterOption,
        attributes = _objectWithoutPropertiesLoose(_this$props2, ["prefixCls", "value", "className", "inputValue", "onRawChange", "disabled", "options", "filterOption"]);

    var optionClassName = classNames((_classNames = {}, _classNames[prefixCls + "-option"] = true, _classNames[prefixCls + "-option-disabled"] = disabled, _classNames[prefixCls + "-option-active"] = // @ts-ignore
    options instanceof Array && options.indexOf(value) !== -1 ? true : options === value ? true : false, _classNames), className);
    var isShow = typeof filterOption === 'function' ? filterOption(inputValue, value) : true;

    if (isShow) {
      return React.createElement("div", _extends({
        className: optionClassName,
        onClick: this.handleOptionClick
      }, attributes));
    }

    return null;
  };

  return Option;
}(React.PureComponent);

export default createConsumer(Option);