import * as React from 'react';
import { SelectProps, SelectState, SelectSize } from './typings';
import Option from './option';
import OptionGroup from './option-group';
declare class Select extends React.PureComponent<SelectProps, SelectState> {
    static Option: typeof Option;
    static OptionGroup: typeof OptionGroup;
    static componentType: string;
    static defaultProps: {
        prefixCls: string;
        size: SelectSize;
    };
    readonly selectElement: React.RefObject<HTMLDivElement>;
    readonly panelElement: React.RefObject<HTMLDivElement>;
    static getDerivedStateFromProps(nextProps: SelectProps): {
        inputValue: string;
        value: string | number | string[] | number[];
        options: string | any[];
    } | {
        value: string | number | string[] | number[];
        inputValue?: undefined;
        options?: undefined;
    };
    constructor(props: SelectProps);
    render(): JSX.Element;
    bindDocumentClick: () => void;
    clearDocumentClick: () => void;
    handleExited: () => void;
    handleDocumentClick: (event: any) => void;
    getPosition: () => {
        left: number;
        top: number;
    };
    handleEnter: () => void;
    handleInputFocus: () => void;
    handleInputChange: (value: string) => void;
    handleRawChange: (value: any) => void;
}
export default Select;
