import * as React from 'react';
export declare type SwitchSize = 'small' | 'default' | 'large';
export declare type SwitchProps = {
    className?: string;
    prefixCls?: string;
    size?: SwitchSize;
    checked?: boolean;
    disabled?: boolean;
    defaultChecked?: boolean;
    checkedChildren?: React.ReactNode;
    unCheckedChildren?: React.ReactNode;
    onChange?: (checked: boolean) => void;
    onClick?: () => void;
};
export interface SwitchState {
    checked?: boolean;
}
declare class Switch extends React.Component<SwitchProps, SwitchState> {
    static componentType: string;
    static defaultProps: {
        disabled: boolean;
        prefixCls: string;
        size: import("../select/typings").SelectSize;
    };
    constructor(props: SwitchProps);
    render(): JSX.Element;
    getChecked: () => boolean;
    handleChange: () => void;
}
export default Switch;
