import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
import _assertThisInitialized from "@babel/runtime/helpers/esm/assertThisInitialized";
import _inheritsLoose from "@babel/runtime/helpers/esm/inheritsLoose";
import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";
import * as classNames from 'classnames';
import * as React from 'react';

var Switch =
/*#__PURE__*/
function (_React$Component) {
  _inheritsLoose(Switch, _React$Component);

  function Switch(props) {
    var _this;

    _this = _React$Component.call(this, props) || this;

    _defineProperty(_assertThisInitialized(_this), "getChecked", function () {
      return 'checked' in _this.props ? _this.props.checked : _this.state.checked;
    });

    _defineProperty(_assertThisInitialized(_this), "handleChange", function () {
      var _this$props = _this.props,
          onChange = _this$props.onChange,
          onClick = _this$props.onClick;
      var checked = !_this.getChecked();

      _this.setState({
        checked: checked
      });

      if (typeof onChange === 'function') {
        onChange(checked);
      }

      if (typeof onClick === 'function') {
        onClick();
      }
    });

    _this.state = {
      checked: 'defaultChecked' in props ? props.defaultChecked : false
    };
    return _this;
  }

  var _proto = Switch.prototype;

  _proto.render = function render() {
    var _classNames;

    var _this$props2 = this.props,
        className = _this$props2.className,
        checkedChildren = _this$props2.checkedChildren,
        unCheckedChildren = _this$props2.unCheckedChildren,
        disabled = _this$props2.disabled,
        size = _this$props2.size,
        prefixCls = _this$props2.prefixCls,
        onClick = _this$props2.onClick,
        onChange = _this$props2.onChange,
        attributes = _objectWithoutPropertiesLoose(_this$props2, ["className", "checkedChildren", "unCheckedChildren", "disabled", "size", "prefixCls", "onClick", "onChange"]);

    var checked = this.getChecked();
    var switchClassName = classNames(prefixCls, (_classNames = {}, _classNames[prefixCls + "-checked"] = checked, _classNames[prefixCls + "-disabled"] = disabled, _classNames[prefixCls + "-small"] = size === 'small', _classNames[prefixCls + "-large"] = size === 'large', _classNames), className);
    return React.createElement("button", _extends({
      className: switchClassName,
      type: "button",
      onClick: this.handleChange
    }, attributes), React.createElement("span", {
      className: prefixCls + "-inner"
    }, checked ? checkedChildren : unCheckedChildren));
  };

  return Switch;
}(React.Component);

_defineProperty(Switch, "componentType", 'Switch');

_defineProperty(Switch, "defaultProps", {
  disabled: false,
  prefixCls: 'dk-switch',
  size: 'default'
});

export default Switch;