import * as React from 'react';
import { PaginationProps } from '../pagination';
export declare type ColumnProps<T> = {
    title?: React.ReactNode;
    dataIndex: string;
    render?: (record: T, index: number, item: any) => React.ReactNode;
    className?: string;
    width?: number;
    fixed?: boolean;
};
export declare type TableProps<T extends object> = {
    prefixCls?: string;
    columns: Array<ColumnProps<T>>;
    dataSource?: T[];
    className?: string;
    fixed?: boolean;
    scroll?: {
        x?: number;
        y?: number;
    };
    pagination?: false | PaginationProps & {
        position?: 'top' | 'bottom';
    };
    title?: string;
    bodyClassName?: string;
};
export declare type TableState = {
    position?: 'left' | 'right' | 'both' | 'middle';
};
declare class TableList<T extends {
    [key: string]: any;
}> extends React.Component<TableProps<T>, TableState> {
    static defaultProps: {
        prefixCls: string;
    };
    lastScrollLeft: number;
    lastScrollTop: number;
    debouncedWindowResize: any;
    resizeEvent: any;
    readonly bodyRef: React.RefObject<HTMLDivElement>;
    readonly headRef: React.RefObject<HTMLDivElement>;
    constructor(props: TableProps<T>);
    componentDidMount(): void;
    componentWillUnmount(): void;
    componentDidUpdate(prevProps: TableProps<T>): void;
    render(): JSX.Element;
    handleBodyScrollLeft: (e: React.FormEvent<EventTarget>) => void;
    setScrollPositionClassName(): void;
    handleWindowResize: () => void;
}
export default TableList;
