"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var React = _interopRequireWildcard(require("react"));

var enzyme = _interopRequireWildcard(require("enzyme"));

var _ = _interopRequireDefault(require(".."));

var prefixCls = 'dk-alert';
describe('Alert[Basic]', function () {
  test("should render ." + prefixCls + " in a Alert", function () {
    var wrapper = enzyme.shallow(React.createElement(_["default"], null, "A simple default alert\u2014check it out!"));
    wrapper.find(_["default"]).forEach(function (child) {
      expect(child.shallow().hasClass(prefixCls)).toBeTruthy();
    });
  });
});
describe('Alert[closable]', function () {
  test("should have close icon when set closable", function () {
    var wrapper = enzyme.shallow(React.createElement(_["default"], {
      type: "info",
      closable: true
    }, "A simple info alert with close button!"));
    var eventMock = {
      preventDefault: jest.fn()
    };
    wrapper.find("." + prefixCls + "-close").simulate('click', eventMock);
    expect(wrapper.find(prefixCls).exists()).toBeFalsy();
  });
});