"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inheritsLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/inheritsLoose"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var React = _interopRequireWildcard(require("react"));

var classNames = _interopRequireWildcard(require("classnames"));

var _reactTransitionGroup = require("react-transition-group");

var _icon = _interopRequireDefault(require("../icon"));

var Alert =
/*#__PURE__*/
function (_React$PureComponent) {
  (0, _inheritsLoose2["default"])(Alert, _React$PureComponent);

  Alert.getDerivedStateFromProps = function getDerivedStateFromProps(nextProps) {
    if ('dismiss' in nextProps) {
      return {
        dismiss: !!nextProps.dismiss
      };
    }

    return null;
  };

  function Alert(props) {
    var _this;

    _this = _React$PureComponent.call(this, props) || this;
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleExited", function () {
      var onClose = _this.props.onClose;

      if (typeof onClose === 'function') {
        onClose();
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleClose", function (e) {
      e.preventDefault();

      if (_this.state.dismiss) {
        return;
      }

      _this.setState({
        dismiss: true
      });
    });
    _this.state = {
      dismiss: false
    };
    return _this;
  }

  var _proto = Alert.prototype;

  _proto.render = function render() {
    var _classNames;

    var _this$props = this.props,
        prefixCls = _this$props.prefixCls,
        className = _this$props.className,
        children = _this$props.children,
        closable = _this$props.closable,
        icon = _this$props.icon,
        type = _this$props.type,
        dismissProp = _this$props.dismiss,
        attributes = (0, _objectWithoutPropertiesLoose2["default"])(_this$props, ["prefixCls", "className", "children", "closable", "icon", "type", "dismiss"]);
    var iconType = {
      success: 'check-circle',
      error: 'x-circle',
      warning: 'alert-circle',
      info: 'info'
    };
    var isShowIcon = icon && iconType[type];
    var alertClassName = classNames(prefixCls, (_classNames = {}, _classNames[prefixCls + "-" + type] = true, _classNames[prefixCls + "-with-close"] = closable, _classNames[prefixCls + "-with-icon"] = isShowIcon, _classNames), className);
    var dismiss = this.state.dismiss;
    return React.createElement(_reactTransitionGroup.CSSTransition, {
      "in": !dismiss,
      timeout: 216,
      unmountOnExit: true,
      classNames: "" + prefixCls,
      onExited: this.handleExited
    }, React.createElement("div", (0, _extends2["default"])({
      className: alertClassName
    }, attributes), isShowIcon ? React.createElement("div", {
      className: prefixCls + "-icon-box"
    }, React.createElement(_icon["default"], {
      type: iconType[type],
      className: prefixCls + "-icon"
    })) : null, children, closable ? React.createElement(_icon["default"], {
      type: "x",
      className: prefixCls + "-close",
      onClick: this.handleClose
    }) : null));
  };

  return Alert;
}(React.PureComponent);

(0, _defineProperty2["default"])(Alert, "defaultProps", {
  prefixCls: 'dk-alert',
  type: 'default',
  closable: false,
  icon: false
});
var _default = Alert;
exports["default"] = _default;