"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = void 0;

var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inheritsLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/inheritsLoose"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var React = _interopRequireWildcard(require("react"));

var classNames = _interopRequireWildcard(require("classnames"));

var _utils = require("./utils");

var _icon = _interopRequireDefault(require("../icon"));

var _time = _interopRequireDefault(require("./time"));

var Day =
/*#__PURE__*/
function (_React$PureComponent) {
  (0, _inheritsLoose2["default"])(Day, _React$PureComponent);

  function Day(props) {
    var _this;

    _this = _React$PureComponent.call(this, props) || this;
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "cachedDate", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "cachedDays", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "renderDay", function (date) {
      var _classNames;

      var _this$props = _this.props,
          current = _this$props.current,
          value = _this$props.value,
          type = _this$props.type,
          prefixCls = _this$props.prefixCls,
          rangeDate = _this$props.rangeDate,
          min = _this$props.min,
          max = _this$props.max;
      var hoverProps = {};
      var isDisabled = !!min && (0, _utils.compareAsc)(date, min) < 0 || !!max && (0, _utils.compareAsc)(date, max) > 0;
      var itemClassName = classNames((_classNames = {}, _classNames[prefixCls + "-day-item"] = true, _classNames[prefixCls + "-day-item-disabled"] = isDisabled, _classNames));

      if (type === 'week') {
        var _classNames2;

        var hoverDate = _this.state.hoverDate;
        hoverProps.onMouseEnter = _this.handleHoverWeek.bind((0, _assertThisInitialized2["default"])(_this), date);
        hoverProps.onMouseLeave = _this.handleHoverWeekLeave;
        itemClassName = classNames(itemClassName, (_classNames2 = {}, _classNames2[prefixCls + "-day-item-other"] = current.getMonth() !== date.getMonth(), _classNames2[prefixCls + "-day-item-hover"] = !!(hoverDate && (0, _utils.isSameWeek)(date, hoverDate)), _classNames2[prefixCls + "-day-item-hover-active"] = value && (0, _utils.isSameWeek)(date, value), _classNames2[prefixCls + "-day-item-hover-start"] = date.getDay() === 0, _classNames2[prefixCls + "-day-item-hover-end"] = date.getDay() === 6, _classNames2));
      } else if (rangeDate && current.getMonth() === date.getMonth()) {
        var _classNames3;

        hoverProps.onMouseEnter = _this.handleDayHover.bind((0, _assertThisInitialized2["default"])(_this), date);
        itemClassName = classNames(itemClassName, (_classNames3 = {}, _classNames3[prefixCls + "-day-item-hover"] = (0, _utils.compareAsc)(rangeDate[0], date) <= 0 && (0, _utils.compareAsc)(rangeDate[1], date) >= 0, _classNames3[prefixCls + "-day-item-hover-active"] = (0, _utils.isSameDay)(rangeDate[0], date) || (0, _utils.isSameDay)(rangeDate[1], date), _classNames3[prefixCls + "-day-item-hover-start"] = (0, _utils.isSameDay)(rangeDate[0], date), _classNames3[prefixCls + "-day-item-hover-end"] = (0, _utils.isSameDay)(rangeDate[1], date), _classNames3));
      } else {
        var _classNames4;

        hoverProps.onMouseEnter = _this.handleDayHover.bind((0, _assertThisInitialized2["default"])(_this), date);
        itemClassName = classNames(itemClassName, (_classNames4 = {}, _classNames4[prefixCls + "-day-item-other"] = current.getMonth() !== date.getMonth(), _classNames4[prefixCls + "-day-item-active"] = value && (0, _utils.isSameDay)(date, value), _classNames4));
      }

      return React.createElement("div", (0, _extends2["default"])({
        key: date.getTime(),
        className: itemClassName,
        onClick: isDisabled ? undefined : _this.handleDayClick.bind((0, _assertThisInitialized2["default"])(_this), date)
      }, hoverProps), React.createElement("span", null, date.getDate()));
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "renderDatetime", function () {
      var _this$props2 = _this.props,
          format = _this$props2.format,
          current = _this$props2.current,
          prefixCls = _this$props2.prefixCls,
          attributes = (0, _objectWithoutPropertiesLoose2["default"])(_this$props2, ["format", "current", "prefixCls"]);
      var match = format.match(/[H|h].*/);
      var newFormat = match ? match[0] : format;
      return React.createElement("div", {
        className: prefixCls + "-day-datetime"
      }, React.createElement(_time["default"], (0, _extends2["default"])({}, attributes, {
        prefixCls: prefixCls,
        current: current,
        format: newFormat,
        className: prefixCls + "-day-datetime-timer",
        onChange: _this.handleTimerChange
      })), React.createElement("span", null, (0, _utils.formatDate)(current, newFormat)));
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "getDays", function () {
      var current = _this.props.current;

      if (_this.cachedDate && _this.cachedDate.getTime() === current.getTime() && _this.cachedDays) {
        return _this.cachedDays;
      }

      _this.cachedDays = (0, _utils.getDaysOfMonth)(current);
      _this.cachedDate = current;
      return _this.cachedDays;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleDayHover", function (date) {
      var onDayHover = _this.props.onDayHover;

      if (typeof onDayHover === 'function') {
        onDayHover(date);
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleTimerChange", function (date) {
      var onChange = _this.props.onChange;
      onChange(date);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleDayClick", function (date) {
      var _this$props3 = _this.props,
          current = _this$props3.current,
          onChange = _this$props3.onChange,
          disabled = _this$props3.disabled,
          type = _this$props3.type;

      if (disabled) {
        return;
      }

      if (type === 'week') {
        if (date.getDay() === 0) {
          date = (0, _utils.addDays)(date, 1);
        }

        onChange(date, true);
      } else {
        var newDate = new Date(date.getFullYear(), date.getMonth(), date.getDate(), current.getHours(), current.getMinutes(), current.getSeconds());
        onChange(newDate, true);
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleMouth", function (month) {
      var _this$props4 = _this.props,
          current = _this$props4.current,
          onChange = _this$props4.onChange,
          disabled = _this$props4.disabled;

      if (disabled) {
        return;
      }

      onChange((0, _utils.addMonths)(current, month));
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handlePrevYear", function () {
      _this.handleMouth(-12);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleNextYear", function () {
      _this.handleMouth(12);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handlePrevMonth", function () {
      _this.handleMouth(-1);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleNextMonth", function () {
      _this.handleMouth(1);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleHoverWeek", function (date) {
      _this.setState({
        hoverDate: date
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleHoverWeekLeave", function () {
      _this.setState({
        hoverDate: null
      });
    });
    _this.cachedDate = null;
    _this.cachedDays = null;
    _this.state = {
      hoverDate: null
    };
    return _this;
  }

  var _proto = Day.prototype;

  _proto.render = function render() {
    var _this2 = this;

    var _this$props5 = this.props,
        prefixCls = _this$props5.prefixCls,
        current = _this$props5.current,
        type = _this$props5.type,
        hideLeftIcon = _this$props5.hideLeftIcon,
        hideRightIcon = _this$props5.hideRightIcon;
    var days = this.getDays();
    return React.createElement("div", {
      className: prefixCls + "-day"
    }, React.createElement("div", {
      className: prefixCls + "-header"
    }, React.createElement("div", {
      className: prefixCls + "-config"
    }, React.createElement(_icon["default"], {
      className: prefixCls + "-config-icon",
      type: "chevrons-left",
      onClick: this.handlePrevYear,
      disabled: hideLeftIcon
    }), React.createElement(_icon["default"], {
      className: classNames(prefixCls + "-config-icon", prefixCls + "-prev-month"),
      type: "chevron-left",
      onClick: this.handlePrevMonth,
      disabled: hideLeftIcon
    }), React.createElement("div", {
      className: prefixCls + "-select"
    }, React.createElement("span", {
      onClick: function onClick() {
        return _this2.props.onModeChange('month');
      }
    }, _utils.monthValues["long"][current.getMonth()]), React.createElement("span", {
      onClick: function onClick() {
        return _this2.props.onModeChange('year');
      }
    }, current.getFullYear())), React.createElement(_icon["default"], {
      className: classNames(prefixCls + "-config-icon", prefixCls + "-next-month"),
      type: "chevron-right",
      onClick: this.handleNextMonth,
      disabled: hideRightIcon
    }), React.createElement(_icon["default"], {
      className: prefixCls + "-config-icon",
      type: "chevrons-right",
      onClick: this.handleNextYear,
      disabled: hideRightIcon
    })), React.createElement("div", {
      className: prefixCls + "-week"
    }, _utils.weekdayValues["short"].map(function (w) {
      return React.createElement("span", {
        key: w
      }, w);
    }))), React.createElement("div", {
      className: prefixCls + "-list"
    }, days.map(function (date) {
      return _this2.renderDay(date);
    })), type === 'datetime' ? this.renderDatetime() : null);
  };

  return Day;
}(React.PureComponent);

(0, _defineProperty2["default"])(Day, "defaultProps", {
  type: 'day'
});
var _default = Day;
exports["default"] = _default;