"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = void 0;

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inheritsLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/inheritsLoose"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var React = _interopRequireWildcard(require("react"));

var classNames = _interopRequireWildcard(require("classnames"));

var _utils = require("./utils");

var _icon = _interopRequireDefault(require("../icon"));

var Month =
/*#__PURE__*/
function (_React$PureComponent) {
  (0, _inheritsLoose2["default"])(Month, _React$PureComponent);

  function Month(props) {
    var _this;

    _this = _React$PureComponent.call(this, props) || this;
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "renderMonth", function (m, key) {
      var _classNames;

      var _this$props = _this.props,
          prefixCls = _this$props.prefixCls,
          current = _this$props.current,
          value = _this$props.value;
      var date = new Date(current.getTime());
      date.setMonth(key);
      var itemClassName = classNames((_classNames = {}, _classNames[prefixCls + "-ym-item"] = true, _classNames[prefixCls + "-ym-item-active"] = value && (0, _utils.isSameMonth)(date, value), _classNames));
      return React.createElement("div", {
        key: key,
        className: itemClassName,
        onClick: _this.handleMonthClick.bind((0, _assertThisInitialized2["default"])(_this), key)
      }, React.createElement("span", null, m));
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleMonthClick", function (i) {
      var _this$props2 = _this.props,
          current = _this$props2.current,
          onChange = _this$props2.onChange,
          type = _this$props2.type,
          disabled = _this$props2.disabled;

      if (disabled) {
        return;
      }

      var date = new Date(current.getTime());
      var isMonth = type === 'month';
      date.setMonth(i, 1);
      onChange(date, isMonth);

      if (!isMonth) {
        _this.props.onModeChange('day');
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleYear", function (year) {
      var _this$props3 = _this.props,
          current = _this$props3.current,
          onChange = _this$props3.onChange,
          disabled = _this$props3.disabled;

      if (disabled) {
        return;
      }

      onChange((0, _utils.addYears)(current, year));
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handlePrevYear", function () {
      _this.handleYear(-1);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleNextYear", function () {
      _this.handleYear(1);
    });
    return _this;
  }

  var _proto = Month.prototype;

  _proto.render = function render() {
    var _this2 = this;

    var _this$props4 = this.props,
        prefixCls = _this$props4.prefixCls,
        current = _this$props4.current,
        hideLeftIcon = _this$props4.hideLeftIcon,
        hideRightIcon = _this$props4.hideRightIcon;
    return React.createElement("div", {
      className: prefixCls + "-ym"
    }, React.createElement("div", {
      className: prefixCls + "-header"
    }, React.createElement("div", {
      className: prefixCls + "-config"
    }, React.createElement(_icon["default"], {
      className: prefixCls + "-config-icon",
      type: "chevrons-left",
      onClick: this.handlePrevYear,
      disabled: hideLeftIcon
    }), React.createElement("div", {
      className: prefixCls + "-select"
    }, React.createElement("span", {
      onClick: function onClick() {
        return _this2.props.onModeChange('year');
      }
    }, current.getFullYear())), React.createElement(_icon["default"], {
      className: prefixCls + "-config-icon",
      type: "chevrons-right",
      onClick: this.handleNextYear,
      disabled: hideRightIcon
    }))), React.createElement("div", {
      className: prefixCls + "-list"
    }, _utils.monthValues["short"].map(function (m, i) {
      return _this2.renderMonth(m, i);
    })));
  };

  return Month;
}(React.PureComponent);

var _default = Month;
exports["default"] = _default;