"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = void 0;

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inheritsLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/inheritsLoose"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var React = _interopRequireWildcard(require("react"));

var classNames = _interopRequireWildcard(require("classnames"));

var _scrollbar = _interopRequireDefault(require("../scrollbar"));

var _number = require("../utils/number");

var _utils = require("./utils");

var itemHeight = 32;

var Time =
/*#__PURE__*/
function (_React$PureComponent) {
  (0, _inheritsLoose2["default"])(Time, _React$PureComponent);

  function Time(props) {
    var _this;

    _this = _React$PureComponent.call(this, props) || this;
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "scrollRef", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleItemClick", function (num) {
      var onChange = _this.props.onChange;
      var scrollbarElement = _this.scrollRef.current;

      if (scrollbarElement) {
        scrollbarElement.scrollTop(num * itemHeight, 120);
      }

      onChange(num);
    });
    _this.state = {
      autoHide: false
    };
    _this.scrollRef = React.createRef();
    return _this;
  }

  var _proto = Time.prototype;

  _proto.componentDidMount = function componentDidMount() {
    var _this2 = this;

    var value = this.props.value;
    var scrollbarElement = this.scrollRef.current;

    if (scrollbarElement) {
      setTimeout(function () {
        scrollbarElement.scrollTop(value * itemHeight);
        setTimeout(function () {
          _this2.setState({
            autoHide: true
          });
        }, 50);
      }, 0);
    }
  };

  _proto.render = function render() {
    var _this3 = this;

    var _this$props = this.props,
        prefixCls = _this$props.prefixCls,
        value = _this$props.value,
        _this$props$total = _this$props.total,
        total = _this$props$total === void 0 ? 0 : _this$props$total;
    return React.createElement(_scrollbar["default"], {
      className: prefixCls + "-time-scroll",
      ref: this.scrollRef,
      autoHide: this.state.autoHide
    }, React.createElement("div", {
      className: prefixCls + "-time-list"
    }, (0, _number.rangeNumber)(total, 0).map(function (num) {
      var _classNames;

      return React.createElement("span", {
        key: num,
        className: classNames((_classNames = {}, _classNames[prefixCls + "-time-item"] = true, _classNames[prefixCls + "-time-item-active"] = num === value, _classNames)),
        onClick: _this3.handleItemClick.bind(_this3, num)
      }, (0, _utils.pad)(num));
    })));
  };

  return Time;
}(React.PureComponent);

var _default = Time;
exports["default"] = _default;