"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inheritsLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/inheritsLoose"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var classNames = _interopRequireWildcard(require("classnames"));

var React = _interopRequireWildcard(require("react"));

var _context = require("./context");

var Card =
/*#__PURE__*/
function (_React$PureComponent) {
  (0, _inheritsLoose2["default"])(Card, _React$PureComponent);

  Card.getDerivedStateFromProps = function getDerivedStateFromProps(nextProps) {
    if ('visible' in nextProps) {
      return {
        visible: nextProps.visible
      };
    }

    return null;
  };

  function Card(props) {
    var _this;

    _this = _React$PureComponent.call(this, props) || this;
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleHeaderClick", function () {
      var visible = _this.state.visible;
      var _this$props = _this.props,
          index = _this$props.index,
          onCollapse = _this$props.onCollapse;

      if (typeof onCollapse === 'function') {
        onCollapse(index);
        return;
      }

      _this.setState({
        visible: !visible
      });
    });
    _this.state = {
      visible: !!props.visible
    };
    return _this;
  }

  var _proto = Card.prototype;

  _proto.render = function render() {
    var _this$props2 = this.props,
        className = _this$props2.className,
        prefixCls = _this$props2.prefixCls,
        children = _this$props2.children,
        collapse = _this$props2.collapse,
        visibleProp = _this$props2.visible,
        onCollapse = _this$props2.onCollapse,
        attributes = (0, _objectWithoutPropertiesLoose2["default"])(_this$props2, ["className", "prefixCls", "children", "collapse", "visible", "onCollapse"]);
    var visible = this.state.visible;
    var cardClassName = classNames(prefixCls, className);
    return React.createElement("div", (0, _extends2["default"])({}, attributes, {
      className: cardClassName
    }), React.createElement(_context.Provider, {
      value: {
        visible: visible,
        collapse: collapse,
        handleHeaderClick: this.handleHeaderClick
      }
    }, children));
  };

  return Card;
}(React.PureComponent);

(0, _defineProperty2["default"])(Card, "Header", void 0);
(0, _defineProperty2["default"])(Card, "Footer", void 0);
(0, _defineProperty2["default"])(Card, "Body", void 0);
(0, _defineProperty2["default"])(Card, "Accordion", void 0);
(0, _defineProperty2["default"])(Card, "Collapse", void 0);
(0, _defineProperty2["default"])(Card, "defaultProps", {
  prefixCls: 'dk-card' // visible: true,

});
var _default = Card;
exports["default"] = _default;