"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inheritsLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/inheritsLoose"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var classNames = _interopRequireWildcard(require("classnames"));

var React = _interopRequireWildcard(require("react"));

var _card = _interopRequireDefault(require("./card"));

var Collapse =
/*#__PURE__*/
function (_React$PureComponent) {
  (0, _inheritsLoose2["default"])(Collapse, _React$PureComponent);

  function Collapse(props) {
    var _this;

    _this = _React$PureComponent.call(this, props) || this;
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleCollapse", function (index) {
      var activeIndexs = _this.state.activeIndexs;
      var newActiveIndexs = activeIndexs.indexOf(index) === -1 ? Array.from(new Set([].concat(activeIndexs, [index]))) : activeIndexs.filter(function (i) {
        return i !== index;
      });

      _this.setState({
        activeIndexs: newActiveIndexs
      });
    });
    _this.state = {
      activeIndexs: props.activeIndexs || props.defaultActiveIndexs || []
    };
    return _this;
  }

  var _proto = Collapse.prototype;

  _proto.render = function render() {
    var _this2 = this;

    var _this$props = this.props,
        className = _this$props.className,
        children = _this$props.children,
        defaultActiveIndexs = _this$props.defaultActiveIndexs,
        activeIndexsProp = _this$props.activeIndexs,
        attributes = (0, _objectWithoutPropertiesLoose2["default"])(_this$props, ["className", "children", "defaultActiveIndexs", "activeIndexs"]);
    var collapseClassName = classNames('dk-card-collapse', className);
    var activeIndexs = this.state.activeIndexs;
    var newChildren = React.Children.map(children, function (child) {
      if (!child) {
        return null;
      }

      var index = child.props.index;
      var newProps = (0, _extends2["default"])({}, child.props, {
        collapse: true,
        visible: activeIndexs.indexOf(index) !== -1,
        onCollapse: _this2.handleCollapse.bind(_this2, index)
      });
      return React.createElement(_card["default"], newProps);
    });
    return React.createElement("div", (0, _extends2["default"])({}, attributes, {
      className: collapseClassName
    }), newChildren);
  };

  return Collapse;
}(React.PureComponent);

var _default = Collapse;
exports["default"] = _default;