"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inheritsLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/inheritsLoose"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var React = _interopRequireWildcard(require("react"));

var classNames = _interopRequireWildcard(require("classnames"));

var _lodashEs = require("lodash-es");

var _context = require("./context");

var CheckboxGroup =
/*#__PURE__*/
function (_React$PureComponent) {
  (0, _inheritsLoose2["default"])(CheckboxGroup, _React$PureComponent);

  CheckboxGroup.getDerivedStateFromProps = function getDerivedStateFromProps(nextProps, prevState) {
    var newValue = nextProps.value;

    if (!Array.isArray(newValue)) {
      newValue = [];
    }

    if (!(0, _lodashEs.isEqual)(newValue, prevState.options)) {
      return {
        options: newValue
      };
    }

    return null;
  };

  function CheckboxGroup(props) {
    var _this;

    _this = _React$PureComponent.call(this, props) || this;
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleRawChange", function (checked, value) {
      var options = _this.state.options;
      var onChange = _this.props.onChange;
      var newOptions = !!checked ? Array.from(new Set([].concat(options, [value]))) : options.filter(function (option) {
        return option !== value;
      });

      _this.setState({
        options: newOptions
      });

      if (typeof onChange === 'function') {
        onChange(newOptions);
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleChecked", function (value) {
      var options = _this.state.options;
      return options.indexOf(value) !== -1;
    });

    var _options = props.defaultValue || props.value || [];

    _this.state = {
      options: _options
    };
    return _this;
  }

  var _proto = CheckboxGroup.prototype;

  _proto.render = function render() {
    var _classNames;

    var _this$props = this.props,
        className = _this$props.className,
        prefixCls = _this$props.prefixCls,
        children = _this$props.children,
        min = _this$props.min,
        max = _this$props.max,
        onChange = _this$props.onChange,
        value = _this$props.value,
        defaultValue = _this$props.defaultValue,
        attributes = (0, _objectWithoutPropertiesLoose2["default"])(_this$props, ["className", "prefixCls", "children", "min", "max", "onChange", "value", "defaultValue"]);
    var options = this.state.options;
    var groupClassName = classNames((_classNames = {}, _classNames[prefixCls + "-group"] = true, _classNames), className);
    return React.createElement("div", (0, _extends2["default"])({
      className: groupClassName
    }, attributes), React.createElement(_context.Provider, {
      value: {
        onRawChange: this.handleRawChange,
        checked: this.handleChecked,
        options: options,
        min: min,
        max: max
      }
    }, children));
  };

  return CheckboxGroup;
}(React.PureComponent);

(0, _defineProperty2["default"])(CheckboxGroup, "componentType", 'CheckboxGroup');
(0, _defineProperty2["default"])(CheckboxGroup, "defaultProps", {
  prefixCls: 'dk-checkbox',
  value: []
});
var _default = CheckboxGroup;
exports["default"] = _default;