"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var React = _interopRequireWildcard(require("react"));

var enzyme = _interopRequireWildcard(require("enzyme"));

var _ = _interopRequireDefault(require(".."));

var _input = _interopRequireDefault(require("../../input"));

var prefixCls = 'dk-form';
it('calls onSubmit prop function when form is submitted', function () {
  var onSubmitFn = jest.fn();
  var wrapper = enzyme.mount(React.createElement(_["default"], {
    onSubmit: onSubmitFn
  }));
  var form = wrapper.find('form');
  form.simulate('submit');
  expect(onSubmitFn).toHaveBeenCalledTimes(1);
});
it('reads and sets input value', function () {
  var onSubmit = function onSubmit(event, values, errors) {
    expect(values.name).toEqual('Yuan Zhaohao');
    var isError = errors && errors.length;
    expect(isError).toBeTruthy();
  };

  var wrapper = enzyme.mount(React.createElement(_["default"], {
    onSubmit: onSubmit
  }, React.createElement(_["default"].Item, {
    label: "First Name",
    name: "name"
  }, React.createElement(_input["default"], {
    name: "name"
  })), React.createElement(_["default"].Item, {
    label: "Email",
    name: "email",
    required: true
  }, React.createElement(_input["default"], null))));
  wrapper.find('input[name="name"]').simulate('change', {
    target: {
      value: 'Yuan Zhaohao'
    }
  });
  wrapper.find('form').simulate('submit');
});