"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = void 0;

var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inheritsLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/inheritsLoose"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var classNames = _interopRequireWildcard(require("classnames"));

var React = _interopRequireWildcard(require("react"));

var _context = require("./context");

var Form =
/*#__PURE__*/
function (_React$Component) {
  (0, _inheritsLoose2["default"])(Form, _React$Component);

  function Form(props) {
    var _this;

    _this = _React$Component.call(this, props) || this;
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "fields", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleSubmit", function (event) {
      var onSubmit = _this.props.onSubmit;

      var values = _this.getFieldsValues();

      var errors = _this.getFiledsErrors();

      if (typeof onSubmit === 'function') {
        onSubmit(event, values, errors.length === 0 ? undefined : errors.filter(function (error) {
          return !!error;
        }), {
          reset: _this.reset
        });
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleReset", function (event) {
      var onReset = _this.props.onReset;

      _this.reset();

      if (typeof onReset === 'function') {
        onReset(event);
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "reset", function () {
      var _assertThisInitialize = (0, _assertThisInitialized2["default"])(_this),
          fields = _assertThisInitialize.fields;

      Object.keys(fields).forEach(function (key) {
        if (fields[key] && fields[key].component) {
          fields[key].component.resetField();
        }
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "addField", function (field) {
      _this.fields = (0, _extends2["default"])({}, _this.fields, field);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "removeField", function (name) {
      if (_this.fields[name]) {
        delete _this.fields[name];
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "getFields", function () {
      return _this.fields;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "getFieldsValues", function () {
      var _assertThisInitialize2 = (0, _assertThisInitialized2["default"])(_this),
          fields = _assertThisInitialize2.fields;

      var values = {};
      Object.keys(fields).forEach(function (key) {
        values[key] = fields[key].component.state.value;
      });
      return values;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "getFiledsErrors", function () {
      var _assertThisInitialize3 = (0, _assertThisInitialized2["default"])(_this),
          fields = _assertThisInitialize3.fields;

      var errors = [];
      Object.keys(fields).forEach(function (key) {
        var error = fields[key].component.checkInvalid();

        if (error && error.message) {
          errors.push(error);
        }
      });
      return errors;
    });
    _this.fields = {};
    return _this;
  }

  var _proto = Form.prototype;

  _proto.render = function render() {
    var _classNames;

    var _this$props = this.props,
        children = _this$props.children,
        prefixCls = _this$props.prefixCls,
        className = _this$props.className,
        onSubmit = _this$props.onSubmit,
        labelWidth = _this$props.labelWidth,
        labelAlign = _this$props.labelAlign,
        rules = _this$props.rules,
        attributes = (0, _objectWithoutPropertiesLoose2["default"])(_this$props, ["children", "prefixCls", "className", "onSubmit", "labelWidth", "labelAlign", "rules"]);
    var formClassName = classNames((_classNames = {}, _classNames["" + prefixCls] = true, _classNames), className);
    return React.createElement("form", (0, _extends2["default"])({}, attributes, {
      className: formClassName,
      onSubmit: this.handleSubmit,
      onReset: this.handleReset
    }), React.createElement(_context.Provider, {
      value: {
        labelAlign: labelAlign,
        labelWidth: labelWidth,
        form: {
          rules: rules,
          getFieldsValues: this.getFieldsValues,
          getFields: this.getFields,
          addField: this.addField,
          removeField: this.removeField
        }
      }
    }, children));
  };

  return Form;
}(React.Component);

(0, _defineProperty2["default"])(Form, "Item", void 0);
(0, _defineProperty2["default"])(Form, "defaultProps", {
  prefixCls: 'dk-form',
  labelAlign: 'right'
});
var _default = Form;
exports["default"] = _default;