"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));

var _inheritsLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/inheritsLoose"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var classNames = _interopRequireWildcard(require("classnames"));

var React = _interopRequireWildcard(require("react"));

function isInteger(value) {
  return typeof value === 'number' && isFinite(value) && Math.floor(value) === value;
}

var Col =
/*#__PURE__*/
function (_React$Component) {
  (0, _inheritsLoose2["default"])(Col, _React$Component);

  function Col() {
    return _React$Component.apply(this, arguments) || this;
  }

  var _proto = Col.prototype;

  _proto.render = function render() {
    var _classNames;

    var props = this.props;
    var _this$props = this.props,
        children = _this$props.children,
        prefixCls = _this$props.prefixCls,
        className = _this$props.className,
        first = _this$props.first,
        last = _this$props.last,
        attributes = (0, _objectWithoutPropertiesLoose2["default"])(_this$props, ["children", "prefixCls", "className", "first", "last"]);
    var classMap = {
      xs: prefixCls + "-col-xs",
      sm: prefixCls + "-col-sm",
      md: prefixCls + "-col-md",
      lg: prefixCls + "-col-lg",
      xl: prefixCls + "-col-xl",
      xsOffset: prefixCls + "-col-xs-offset",
      smOffset: prefixCls + "-col-sm-offset",
      mdOffset: prefixCls + "-col-md-offset",
      lgOffset: prefixCls + "-col-lg-offset",
      xlOffset: prefixCls + "-col-xl-offset"
    };
    var colKeysClassNames = Object.keys(attributes).filter(function (key) {
      return classMap[key];
    }).map(function (key) {
      delete attributes[key];

      if (isInteger(props[key])) {
        return classMap[key] + '-' + props[key];
      }

      return classMap[key];
    });
    var rowClassName = classNames(colKeysClassNames, (_classNames = {}, _classNames[prefixCls + "-first-" + first] = first !== undefined, _classNames[prefixCls + "-last-" + last] = last !== undefined, _classNames), className);
    return React.createElement("div", (0, _extends2["default"])({
      className: rowClassName
    }, attributes), children);
  };

  return Col;
}(React.Component);

(0, _defineProperty2["default"])(Col, "defaultProps", {
  prefixCls: 'dk-grid'
});
var _default = Col;
exports["default"] = _default;