"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inheritsLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/inheritsLoose"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var React = _interopRequireWildcard(require("react"));

var classNames = _interopRequireWildcard(require("classnames"));

var rowKeys = ['start', 'center', 'end', 'top', 'middle', 'bottom', 'around', 'between'];

var Row =
/*#__PURE__*/
function (_React$Component) {
  (0, _inheritsLoose2["default"])(Row, _React$Component);

  function Row() {
    var _this;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _React$Component.call.apply(_React$Component, [this].concat(args)) || this;
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "getRowClassNames", function () {
      var prefixCls = _this.props.prefixCls;
      return rowKeys.map(function (key) {
        var value = _this.props[key];

        if (!!value) {
          var _ref;

          return _ref = {}, _ref[prefixCls + "-" + key + "-" + value] = true, _ref;
        }

        return null;
      });
    });
    return _this;
  }

  var _proto = Row.prototype;

  _proto.render = function render() {
    var _classNames;

    var _this$props = this.props,
        children = _this$props.children,
        prefixCls = _this$props.prefixCls,
        className = _this$props.className,
        reverse = _this$props.reverse,
        attributes = (0, _objectWithoutPropertiesLoose2["default"])(_this$props, ["children", "prefixCls", "className", "reverse"]);
    var rowKeysClassNames = this.getRowClassNames();
    var rowClassName = classNames(prefixCls + "-row", rowKeysClassNames, (_classNames = {}, _classNames[prefixCls + "-row-reverse"] = reverse, _classNames), className);
    rowKeys.forEach(function (key) {
      delete attributes[key];
    });
    return React.createElement("div", (0, _extends2["default"])({
      className: rowClassName
    }, attributes), children);
  };

  return Row;
}(React.Component);

(0, _defineProperty2["default"])(Row, "defaultProps", {
  prefixCls: 'dk-grid',
  reverse: false
});
var _default = Row;
exports["default"] = _default;