"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inheritsLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/inheritsLoose"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var React = _interopRequireWildcard(require("react"));

var classNames = _interopRequireWildcard(require("classnames"));

var _icon = _interopRequireDefault(require("../icon"));

function fixControlledValue(value) {
  if (typeof value === 'undefined' || value === null) {
    return '';
  }

  return value;
}

var Input =
/*#__PURE__*/
function (_React$Component) {
  (0, _inheritsLoose2["default"])(Input, _React$Component);

  Input.getDerivedStateFromProps = function getDerivedStateFromProps(nextProps) {
    if ('value' in nextProps) {
      return {
        value: nextProps.value
      };
    }

    return null;
  };

  function Input(props) {
    var _this;

    _this = _React$Component.call(this, props) || this;
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleChange", function (event) {
      var onChange = _this.props.onChange;
      var value = event.target.value;

      if (_this.invalidNumber(value)) {
        return;
      }

      if (onChange) {
        onChange(value);
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleBlur", function (event) {
      var value = event.target.value;
      var onBlur = _this.props.onBlur;

      if (onBlur) {
        onBlur(event);
      }

      if (_this.invalidNumber(value)) {
        return;
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleFocus", function (event) {
      var onFocus = _this.props.onFocus;

      if (onFocus) {
        onFocus(event);
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "invalidNumber", function (value) {
      var _this$props = _this.props,
          digits = _this$props.digits,
          type = _this$props.type;

      if (type !== 'number') {
        return false;
      }

      var reg = '^-?\\d*';

      if (digits === undefined) {
        reg += '\\.?\\d*';
      } else if (digits > 0) {
        reg += "\\.?\\d{0," + digits + "}";
      }

      reg += '$';
      return !new RegExp(reg).test(value);
    });
    _this.state = {
      value: props.value
    };
    return _this;
  }

  var _proto = Input.prototype;

  _proto.render = function render() {
    var _classNames;

    var _this$props2 = this.props,
        children = _this$props2.children,
        className = _this$props2.className,
        disabled = _this$props2.disabled,
        size = _this$props2.size,
        type = _this$props2.type,
        prefixCls = _this$props2.prefixCls,
        prefix = _this$props2.prefix,
        suffix = _this$props2.suffix,
        prefixClassName = _this$props2.prefixClassName,
        suffixClassName = _this$props2.suffixClassName,
        _this$props2$wrapperP = _this$props2.wrapperProps,
        wrapperProps = _this$props2$wrapperP === void 0 ? {} : _this$props2$wrapperP,
        wrapperRef = _this$props2.wrapperRef,
        status = _this$props2.status,
        attributes = (0, _objectWithoutPropertiesLoose2["default"])(_this$props2, ["children", "className", "disabled", "size", "type", "prefixCls", "prefix", "suffix", "prefixClassName", "suffixClassName", "wrapperProps", "wrapperRef", "status"]);
    var value = this.props.value;
    var inputClassName = classNames(prefixCls, (_classNames = {}, _classNames[prefixCls + "-large"] = size === 'large', _classNames[prefixCls + "-small"] = size === 'small', _classNames[prefixCls + "-prefix"] = prefix, _classNames[prefixCls + "-suffix"] = suffix, _classNames[prefixCls + "-" + status] = status !== 'default', _classNames), className);
    var inputType = type === 'password' ? 'password' : 'text';

    if ('value' in this.props) {
      attributes.value = fixControlledValue(value);
      delete attributes.defaultValue;
    }

    var inputNode = React.createElement("input", (0, _extends2["default"])({}, attributes, {
      className: inputClassName,
      readOnly: disabled,
      type: inputType,
      onChange: this.handleChange,
      onBlur: this.handleBlur,
      onFocus: this.handleFocus
    }));
    var wrapperClassName = wrapperProps.className,
        otherWrapperProps = (0, _objectWithoutPropertiesLoose2["default"])(wrapperProps, ["className"]);
    return prefix || suffix ? React.createElement("div", (0, _extends2["default"])({
      className: classNames(prefixCls + "-wrapper", wrapperClassName)
    }, otherWrapperProps), prefix ? React.createElement(_icon["default"], {
      type: prefix,
      className: classNames(prefixCls + "-prefix-icon", prefixClassName)
    }) : null, inputNode, suffix ? React.createElement(_icon["default"], {
      type: suffix,
      className: classNames(prefixCls + "-suffix-icon", suffixClassName)
    }) : null) : inputNode;
  };

  return Input;
}(React.Component);

(0, _defineProperty2["default"])(Input, "componentType", 'Input');
(0, _defineProperty2["default"])(Input, "defaultProps", {
  prefixCls: 'dk-input',
  size: 'default',
  status: 'default',
  type: 'text'
});
var _default = Input;
exports["default"] = _default;