"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inheritsLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/inheritsLoose"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var React = _interopRequireWildcard(require("react"));

var classNames = _interopRequireWildcard(require("classnames"));

var _sidebar = _interopRequireDefault(require("./sidebar"));

var _context = require("./context");

var Layout =
/*#__PURE__*/
function (_React$Component) {
  (0, _inheritsLoose2["default"])(Layout, _React$Component);

  function Layout() {
    var _this;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _React$Component.call.apply(_React$Component, [this].concat(args)) || this;
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "state", {
      sidebars: []
    });
    return _this;
  }

  var _proto = Layout.prototype;

  _proto.render = function render() {
    var _classNames;

    var _this$props = this.props,
        prefixCls = _this$props.prefixCls,
        className = _this$props.className,
        children = _this$props.children,
        hasSidebar = _this$props.hasSidebar,
        attibutes = (0, _objectWithoutPropertiesLoose2["default"])(_this$props, ["prefixCls", "className", "children", "hasSidebar"]);
    var layoutClassName = classNames((_classNames = {}, _classNames["" + prefixCls] = true, _classNames[prefixCls + "-has-sidebar"] = hasSidebar || this.state.sidebars.length > 0, _classNames), className);
    return React.createElement("div", (0, _extends2["default"])({
      className: layoutClassName
    }, attibutes), React.createElement(_context.LayoutProvider, {
      value: this.getLayoutContext()
    }, children));
  };

  _proto.getLayoutContext = function getLayoutContext() {
    var _this2 = this;

    return {
      addSidebar: function addSidebar(id) {
        _this2.setState({
          sidebars: [].concat(_this2.state.sidebars, [id])
        });
      },
      removeSidebar: function removeSidebar(id) {
        _this2.setState({
          sidebars: _this2.state.sidebars.filter(function (currentId) {
            return currentId !== id;
          })
        });
      }
    };
  };

  return Layout;
}(React.Component);

(0, _defineProperty2["default"])(Layout, "Header", void 0);
(0, _defineProperty2["default"])(Layout, "Footer", void 0);
(0, _defineProperty2["default"])(Layout, "Content", void 0);
(0, _defineProperty2["default"])(Layout, "Sidebar", void 0);
(0, _defineProperty2["default"])(Layout, "defaultProps", {
  prefixCls: 'dk-layout',
  hasSidebar: false
});

function generator(cls) {
  var _class, _temp;

  return _temp = _class =
  /*#__PURE__*/
  function (_React$Component2) {
    (0, _inheritsLoose2["default"])(Basic, _React$Component2);

    function Basic() {
      return _React$Component2.apply(this, arguments) || this;
    }

    var _proto2 = Basic.prototype;

    _proto2.render = function render() {
      var _this$props2 = this.props,
          prefixCls = _this$props2.prefixCls,
          className = _this$props2.className,
          children = _this$props2.children,
          attibutes = (0, _objectWithoutPropertiesLoose2["default"])(_this$props2, ["prefixCls", "className", "children"]);
      var basicClassName = classNames(prefixCls + "-" + cls, className);
      return React.createElement("div", (0, _extends2["default"])({
        className: basicClassName
      }, attibutes), children);
    };

    return Basic;
  }(React.Component), (0, _defineProperty2["default"])(_class, "defaultProps", {
    prefixCls: 'dk-layout'
  }), _temp;
}

var Header = generator('header');
var Footer = generator('footer');
var Content = generator('content');
Layout.Header = Header;
Layout.Footer = Footer;
Layout.Content = Content;
Layout.Sidebar = _sidebar["default"];
var _default = Layout;
exports["default"] = _default;