"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inheritsLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/inheritsLoose"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var React = _interopRequireWildcard(require("react"));

var classNames = _interopRequireWildcard(require("classnames"));

var _context = require("./context");

var generateId = function () {
  var i = 0;
  return function (prefix) {
    if (prefix === void 0) {
      prefix = '';
    }

    i += 1;
    return "" + prefix + i;
  };
}();

var Sidebar =
/*#__PURE__*/
function (_React$Component) {
  (0, _inheritsLoose2["default"])(Sidebar, _React$Component);

  function Sidebar(props) {
    var _this;

    _this = _React$Component.call(this, props) || this;
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "uniqueId", void 0);
    _this.uniqueId = generateId('dashkit-sidebar-');
    return _this;
  }

  var _proto = Sidebar.prototype;

  _proto.componentDidMount = function componentDidMount() {
    if (this.props.addSidebar) {
      this.props.addSidebar(this.uniqueId);
    }
  };

  _proto.componentWillUnmount = function componentWillUnmount() {
    if (this.props.removeSidebar) {
      this.props.removeSidebar(this.uniqueId);
    }
  };

  _proto.render = function render() {
    var _this$props = this.props,
        className = _this$props.className,
        children = _this$props.children,
        addSidebar = _this$props.addSidebar,
        removeSidebar = _this$props.removeSidebar,
        attributes = (0, _objectWithoutPropertiesLoose2["default"])(_this$props, ["className", "children", "addSidebar", "removeSidebar"]);
    var layoutClassName = classNames('dk-layout-sidebar', className);
    return React.createElement("div", (0, _extends2["default"])({}, attributes, {
      className: layoutClassName
    }), children);
  };

  return Sidebar;
}(React.Component);

var _default = (0, _context.createConsumer)(Sidebar);

exports["default"] = _default;