"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));

var _inheritsLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/inheritsLoose"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var React = _interopRequireWildcard(require("react"));

var classNames = _interopRequireWildcard(require("classnames"));

var _context = require("./context");

var _item = _interopRequireDefault(require("./item"));

var _itemGroup = _interopRequireDefault(require("./item-group"));

var _subMenu = _interopRequireDefault(require("./sub-menu"));

var Menu =
/*#__PURE__*/
function (_React$Component) {
  (0, _inheritsLoose2["default"])(Menu, _React$Component);

  Menu.getDerivedStateFromProps = function getDerivedStateFromProps(nextProps) {
    if ('activeKey' in nextProps) {
      return {
        activeIndex: nextProps.activeKey
      };
    }

    return null;
  };

  function Menu(props) {
    var _this;

    _this = _React$Component.call(this, props) || this;
    _this.state = {
      activeIndex: props.activeKey || props.defaultActiveKey,
      openedMenus: props.defaultOpenKeys || []
    };
    return _this;
  }

  var _proto = Menu.prototype;

  _proto.render = function render() {
    var _classNames;

    var _this$props = this.props,
        children = _this$props.children,
        prefixCls = _this$props.prefixCls,
        className = _this$props.className,
        onOpen = _this$props.onOpen,
        onSelect = _this$props.onSelect,
        theme = _this$props.theme,
        mode = _this$props.mode,
        defaultActiveKey = _this$props.defaultActiveKey,
        defaultOpenKeys = _this$props.defaultOpenKeys,
        attributes = (0, _objectWithoutPropertiesLoose2["default"])(_this$props, ["children", "prefixCls", "className", "onOpen", "onSelect", "theme", "mode", "defaultActiveKey", "defaultOpenKeys"]);
    var menuClassName = classNames((_classNames = {}, _classNames["" + prefixCls] = true, _classNames[prefixCls + "-vertical"] = mode === 'vertical', _classNames[prefixCls + "-horizontal"] = mode === 'horizontal', _classNames[prefixCls + "-dark"] = theme === 'dark', _classNames), className);
    return React.createElement("ul", (0, _extends2["default"])({
      className: menuClassName
    }, attributes), React.createElement(_context.MenuProvider, {
      value: this.getMenuContext()
    }, children));
  };

  _proto.getMenuContext = function getMenuContext() {
    var _this2 = this;

    return {
      getState: function getState() {
        return _this2.state;
      },
      getProps: function getProps() {
        return _this2.props;
      },
      selectItem: function selectItem(index) {
        var activeIndex = _this2.state.activeIndex;
        var onSelect = _this2.props.onSelect;

        if (index !== activeIndex) {
          _this2.setState({
            activeIndex: index
          });

          if (typeof onSelect === 'function') {
            onSelect(index);
          }
        }
      },
      addOpenedMenu: function addOpenedMenu(index) {
        var openedMenus = _this2.state.openedMenus;
        var onOpen = _this2.props.onOpen;

        _this2.setState({
          openedMenus: Array.from(new Set([].concat(openedMenus, [index])))
        });

        if (typeof onOpen === 'function') {
          onOpen(index);
        }
      },
      removeOpenedMenu: function removeOpenedMenu(index) {
        var openedMenus = _this2.state.openedMenus;

        _this2.setState({
          openedMenus: openedMenus.filter(function (m) {
            return m !== index;
          })
        });
      },
      existOpenedMenu: function existOpenedMenu(index) {
        return _this2.state.openedMenus.indexOf(index) !== -1;
      }
    };
  };

  return Menu;
}(React.Component);

(0, _defineProperty2["default"])(Menu, "Item", void 0);
(0, _defineProperty2["default"])(Menu, "ItemGroup", void 0);
(0, _defineProperty2["default"])(Menu, "SubMenu", void 0);
(0, _defineProperty2["default"])(Menu, "defaultProps", {
  prefixCls: 'dk-menu',
  mode: 'vertical',
  theme: 'light'
});
Menu.Item = _item["default"];
Menu.SubMenu = _subMenu["default"];
Menu.ItemGroup = _itemGroup["default"];
var _default = Menu;
exports["default"] = _default;