"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inheritsLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/inheritsLoose"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var React = _interopRequireWildcard(require("react"));

var classNames = _interopRequireWildcard(require("classnames"));

var _context = require("./context");

var _icon = _interopRequireDefault(require("../icon"));

var MenuItem =
/*#__PURE__*/
function (_React$Component) {
  (0, _inheritsLoose2["default"])(MenuItem, _React$Component);

  function MenuItem() {
    var _this;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _React$Component.call.apply(_React$Component, [this].concat(args)) || this;
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleClick", function (e) {
      e.preventDefault();
      e.stopPropagation();
      var _this$props = _this.props,
          rootContext = _this$props.rootContext,
          index = _this$props.index;
      rootContext.selectItem(index);
    });
    return _this;
  }

  var _proto = MenuItem.prototype;

  _proto.render = function render() {
    var _classNames;

    var _this$props2 = this.props,
        children = _this$props2.children,
        prefixCls = _this$props2.prefixCls,
        className = _this$props2.className,
        index = _this$props2.index,
        disabled = _this$props2.disabled,
        rootContext = _this$props2.rootContext,
        icon = _this$props2.icon,
        attributes = (0, _objectWithoutPropertiesLoose2["default"])(_this$props2, ["children", "prefixCls", "className", "index", "disabled", "rootContext", "icon"]);
    var rootState = rootContext.getState();
    var isHorizontal = rootContext.getProps().mode === 'horizontal';
    var itemClassName = classNames((_classNames = {}, _classNames[prefixCls + "-item"] = true, _classNames[prefixCls + "-horizontal-item"] = isHorizontal, _classNames[prefixCls + "-item-active"] = rootState.activeIndex === index, _classNames[prefixCls + "-item-disabled"] = disabled, _classNames), className);
    var iconNode = icon && typeof icon === 'string' ? React.createElement(_icon["default"], {
      type: icon,
      className: prefixCls + "-icon"
    }) : null;
    return React.createElement("li", (0, _extends2["default"])({
      className: itemClassName,
      onClick: disabled ? undefined : this.handleClick
    }, attributes), iconNode, children);
  };

  return MenuItem;
}(React.Component);

(0, _defineProperty2["default"])(MenuItem, "defaultProps", {
  prefixCls: 'dk-menu',
  disabled: false
});

var _default = (0, _context.createConsumer)(MenuItem);

exports["default"] = _default;