"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inheritsLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/inheritsLoose"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var React = _interopRequireWildcard(require("react"));

var classNames = _interopRequireWildcard(require("classnames"));

var _reactTransitionGroup = require("react-transition-group");

var _reactDom = require("react-dom");

var _context = require("./context");

var _dom = require("../utils/dom");

var _icon = _interopRequireDefault(require("../icon"));

var SubMenu =
/*#__PURE__*/
function (_React$Component) {
  (0, _inheritsLoose2["default"])(SubMenu, _React$Component);

  function SubMenu(props) {
    var _this;

    _this = _React$Component.call(this, props) || this;
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "titleRef", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "hoverTimer", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "position", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleClick", function () {
      var _this$props = _this.props,
          index = _this$props.index,
          rootContext = _this$props.rootContext;

      if (!rootContext.existOpenedMenu(index)) {
        rootContext.addOpenedMenu(index);
      } else {
        rootContext.removeOpenedMenu(index);
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleMouseEnter", function () {
      var _this$props2 = _this.props,
          index = _this$props2.index,
          rootContext = _this$props2.rootContext;
      window.clearTimeout(_this.hoverTimer);
      _this.hoverTimer = window.setTimeout(function () {
        if (!rootContext.existOpenedMenu(index)) {
          _this.position = _this.getPosition();
          rootContext.addOpenedMenu(index);
          window.setTimeout(function () {
            _this.setState({
              active: true
            });
          }, 0);
        }
      }, 300);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleMouseLeave", function () {
      window.clearTimeout(_this.hoverTimer);
      _this.hoverTimer = window.setTimeout(function () {
        _this.setState({
          active: false
        });
      }, 300);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleEnter", function (el) {
      var prefixCls = _this.props.prefixCls;
      (0, _dom.removeClass)(el, prefixCls + "-submenu-list-opened");

      if (el.scrollHeight !== 0) {
        el.style.height = el.scrollHeight + 'px';
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleEntered", function (el) {
      el.style.height = '';
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleExit", function (el) {
      el.style.height = el.scrollHeight + 'px';
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleExiting", function (el) {
      if (el.scrollHeight !== 0) {
        el.style.height = '0';
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleExited", function () {
      var _this$props3 = _this.props,
          index = _this$props3.index,
          rootContext = _this$props3.rootContext;
      rootContext.removeOpenedMenu(index);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "getPosition", function () {
      var titleDiv = _this.titleRef.current;
      var left = 0;
      var top = 0;

      if (titleDiv && document.documentElement) {
        var rect = titleDiv.getBoundingClientRect();
        var scrollTop = document.documentElement.scrollTop || document.body.scrollTop;
        var scrollLeft = document.documentElement.scrollLeft || document.body.scrollLeft;
        left = scrollLeft + rect.left;
        top = scrollTop + rect.top + rect.height;
      }

      return {
        left: left,
        top: top
      };
    });
    _this.hoverTimer = 0;
    _this.titleRef = React.createRef();
    _this.position = {
      left: 0,
      top: 0
    };
    _this.state = {
      active: props.rootContext.existOpenedMenu(props.index)
    };
    return _this;
  }

  var _proto = SubMenu.prototype;

  _proto.render = function render() {
    var _classNames, _classNames2, _classNames3, _classNames4;

    var _this$props4 = this.props,
        children = _this$props4.children,
        index = _this$props4.index,
        prefixCls = _this$props4.prefixCls,
        className = _this$props4.className,
        icon = _this$props4.icon,
        title = _this$props4.title,
        rootContext = _this$props4.rootContext,
        attributes = (0, _objectWithoutPropertiesLoose2["default"])(_this$props4, ["children", "index", "prefixCls", "className", "icon", "title", "rootContext"]);
    var opened = rootContext.existOpenedMenu(index);
    var rootProps = rootContext.getProps();
    var isHorizontal = rootProps.mode === 'horizontal';
    var active = isHorizontal ? this.state.active : opened;
    var iconNode = icon && typeof icon === 'string' && React.createElement(_icon["default"], {
      type: icon,
      className: prefixCls + "-icon"
    });
    var childNode = children && React.createElement(_reactTransitionGroup.CSSTransition, {
      "in": active,
      timeout: 350,
      onEnter: this.handleEnter,
      onEntered: this.handleEntered,
      onExit: this.handleExit,
      onExiting: this.handleExiting,
      onExited: this.handleExited,
      classNames: prefixCls + "-submenu-list"
    }, React.createElement("ul", {
      className: classNames((_classNames = {}, _classNames[prefixCls + "-submenu-list"] = true, _classNames[prefixCls + "-dark-submenu-list"] = rootProps.theme === 'dark', _classNames[prefixCls + "-horizontal-submenu-list"] = isHorizontal, _classNames[prefixCls + "-submenu-list-opened"] = !isHorizontal && opened, _classNames)),
      style: isHorizontal ? this.position : undefined,
      onMouseEnter: isHorizontal ? this.handleMouseEnter : undefined,
      onMouseLeave: isHorizontal ? this.handleMouseLeave : undefined
    }, children));
    var titleClassName = classNames((_classNames2 = {}, _classNames2[prefixCls + "-submenu-title"] = true, _classNames2[prefixCls + "-horizontal-submenu-title"] = isHorizontal, _classNames2[prefixCls + "-active"] = opened, _classNames2));
    var titleNode = React.createElement("div", {
      className: titleClassName,
      onClick: !isHorizontal ? this.handleClick : null,
      onMouseEnter: isHorizontal ? this.handleMouseEnter : null,
      onMouseLeave: isHorizontal ? this.handleMouseLeave : null,
      ref: this.titleRef
    }, iconNode, title, React.createElement(_icon["default"], {
      type: "chevron-down",
      className: classNames((_classNames3 = {}, _classNames3[prefixCls + "-arrow"] = true, _classNames3[prefixCls + "-arrow-active"] = active, _classNames3))
    }));
    return React.createElement("div", (0, _extends2["default"])({
      className: classNames((_classNames4 = {}, _classNames4[prefixCls + "-submenu"] = true, _classNames4), className)
    }, attributes), titleNode, !isHorizontal ? childNode : // : createPortal(childNode, document.body)
    opened ? (0, _reactDom.createPortal)(childNode, document.body) : null);
  };

  return SubMenu;
}(React.Component);

(0, _defineProperty2["default"])(SubMenu, "Item", void 0);
(0, _defineProperty2["default"])(SubMenu, "defaultProps", {
  prefixCls: 'dk-menu'
});

var _default = (0, _context.createConsumer)(SubMenu);

exports["default"] = _default;