"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = void 0;

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var React = _interopRequireWildcard(require("react"));

var ReactDOM = _interopRequireWildcard(require("react-dom"));

var _message = _interopRequireDefault(require("./message"));

var prefixCls = 'dk-msg';
var defaultDuration = 2.5;
var defaultTransitionDuration = 0.216;
var defaultMax = 100;
var element = null;
var component = null;
var now = Date.now();
var seed = 0;

function getUid() {
  return "dashkit-message-" + now + "-" + seed++;
}

function destroy() {
  if (component) {
    component = null;
  }

  if (element) {
    document.body.removeChild(element);
    element = null;
  }
}

function getComponent() {
  if (!component) {
    var div = document.createElement('div');
    element = div;
    document.body.appendChild(div);
    component = ReactDOM.render(React.createElement(_message["default"], {
      prefixCls: prefixCls,
      max: defaultMax,
      transitionDuration: defaultTransitionDuration,
      onDestory: destroy
    }), div);
  }

  return component;
}

function create(type) {
  return (
    /*#__PURE__*/
    function () {
      var _ref = (0, _asyncToGenerator2["default"])(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee(content, duration, onClose) {
        var messager;
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                messager = getComponent();

                if (duration === undefined) {
                  duration = defaultDuration;
                }

                messager.addMessage({
                  id: getUid(),
                  content: content,
                  duration: duration,
                  type: type,
                  onClose: onClose
                });

              case 3:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }));

      return function (_x, _x2, _x3) {
        return _ref.apply(this, arguments);
      };
    }()
  );
}

var _default = {
  show: create('default'),
  success: create('success'),
  info: create('info'),
  warning: create('warning'),
  error: create('error')
};
exports["default"] = _default;