"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = void 0;

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inheritsLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/inheritsLoose"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var React = _interopRequireWildcard(require("react"));

var _alert = _interopRequireDefault(require("../alert"));

var MessageItem =
/*#__PURE__*/
function (_React$PureComponent) {
  (0, _inheritsLoose2["default"])(MessageItem, _React$PureComponent);

  function MessageItem(props) {
    var _this;

    _this = _React$PureComponent.call(this, props) || this;
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "closeTimer", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "close", function () {
      _this.clearCloseTimer();

      _this.setState({
        dismiss: true
      });

      setTimeout(function () {
        if (typeof _this.props.onClose === 'function') {
          _this.props.onClose();
        }
      }, 0);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "startCloseTimer", function () {
      if (_this.props.duration) {
        _this.closeTimer = window.setTimeout(function () {
          _this.close();
        }, _this.props.duration * 1000);
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "clearCloseTimer", function () {
      if (_this.closeTimer) {
        clearTimeout(_this.closeTimer);
        _this.closeTimer = 0;
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "destory", function () {
      _this.setState({
        closed: true
      });
    });
    _this.closeTimer = 0;
    _this.state = {
      dismiss: false,
      closed: false
    };
    return _this;
  }

  var _proto = MessageItem.prototype;

  _proto.componentDidMount = function componentDidMount() {
    this.startCloseTimer();
  };

  _proto.componentDidUpdate = function componentDidUpdate(prevProps) {
    if (this.props.duration !== prevProps.duration) {
      this.restartCloseTimer();
    }
  };

  _proto.componentWillUnmount = function componentWillUnmount() {
    this.clearCloseTimer();
  };

  _proto.restartCloseTimer = function restartCloseTimer() {
    this.clearCloseTimer();
    this.startCloseTimer();
  };

  _proto.render = function render() {
    var _this$props = this.props,
        prefixCls = _this$props.prefixCls,
        type = _this$props.type,
        content = _this$props.content;
    var _this$state = this.state,
        dismiss = _this$state.dismiss,
        closed = _this$state.closed;
    return closed ? null : React.createElement("div", {
      className: prefixCls + "-item",
      onMouseEnter: this.clearCloseTimer,
      onMouseLeave: this.startCloseTimer
    }, React.createElement(_alert["default"], {
      className: prefixCls + "-content",
      onClose: this.destory,
      dismiss: dismiss,
      type: type,
      icon: true
    }, content));
  };

  return MessageItem;
}(React.PureComponent);

var _default = MessageItem;
exports["default"] = _default;