"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = void 0;

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inheritsLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/inheritsLoose"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var React = _interopRequireWildcard(require("react"));

var _reactTransitionGroup = require("react-transition-group");

var _item = _interopRequireDefault(require("./item"));

var Message =
/*#__PURE__*/
function (_React$PureComponent) {
  (0, _inheritsLoose2["default"])(Message, _React$PureComponent);

  function Message(props) {
    var _this;

    _this = _React$PureComponent.call(this, props) || this;
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "addMessage", function (message) {
      var max = _this.props.max;
      var messages = _this.state.messages;
      var tempMessages = [].concat(messages, [message]);

      if (tempMessages.length > max) {
        tempMessages.unshift();
      }

      _this.setState({
        messages: tempMessages
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "removeMessage", function (id) {
      var _this$props = _this.props,
          transitionDuration = _this$props.transitionDuration,
          onDestory = _this$props.onDestory;
      var messages = _this.state.messages;
      var tempMessages = messages.filter(function (message) {
        return message.id !== id;
      });

      _this.setState({
        messages: tempMessages
      }); // if (tempMessages.length === 0) {
      //   setTimeout(() => {
      //     if (typeof onDestory === 'function') {
      //       if (window.requestAnimationFrame) {
      //         window.requestAnimationFrame(() => {
      //           onDestory();
      //         });
      //       } else {
      //         onDestory();
      //       }
      //     }
      //   }, transitionDuration * 1000);
      // }

    });
    _this.state = {
      messages: []
    };
    return _this;
  }

  var _proto = Message.prototype;

  _proto.render = function render() {
    var _this2 = this;

    var prefixCls = this.props.prefixCls;
    var messages = this.state.messages;
    return React.createElement(_reactTransitionGroup.TransitionGroup, {
      className: prefixCls
    }, messages && messages.length ? messages.map(function (_ref) {
      var id = _ref.id,
          type = _ref.type,
          content = _ref.content,
          duration = _ref.duration,
          _onClose = _ref.onClose;
      return React.createElement(_item["default"], {
        key: id,
        type: type,
        content: content,
        prefixCls: prefixCls,
        duration: duration,
        onClose: function onClose() {
          _this2.removeMessage(id);

          if (typeof _onClose === 'function') {
            _onClose();
          }
        }
      });
    }) : null);
  };

  return Message;
}(React.PureComponent);

var _default = Message;
exports["default"] = _default;