"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.create = create;

var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var React = _interopRequireWildcard(require("react"));

var ReactDOM = _interopRequireWildcard(require("react-dom"));

var classNames = _interopRequireWildcard(require("classnames"));

var _panel = _interopRequireDefault(require("./panel"));

var _button = _interopRequireDefault(require("../button"));

var _icon = _interopRequireDefault(require("../icon"));

function create(type) {
  return function (options) {
    if (options === void 0) {
      options = {};
    }

    var div = document.createElement('div');
    document.body.appendChild(div);
    var props = (0, _extends2["default"])({
      prefixCls: 'dk-modal',
      width: 420
    }, options);
    ReactDOM.render(getPanel(props), div);
    setTimeout(function () {
      props.visible = true;
      ReactDOM.render(getPanel(props), div);
    }, 10);

    function destroy() {
      var unmountResult = ReactDOM.unmountComponentAtNode(div);

      if (unmountResult && div.parentNode) {
        div.parentNode.removeChild(div);
      }
    }

    function update(newProps) {
      if (newProps === void 0) {
        newProps = {};
      }

      props = (0, _extends2["default"])({}, props, newProps);
      ReactDOM.render(getPanel(props), div);
    }

    function getPanel(props) {
      var _classNames;

      var title = props.title,
          content = props.content,
          prefixCls = props.prefixCls,
          onConfirm = props.onConfirm,
          attributes = (0, _objectWithoutPropertiesLoose2["default"])(props, ["title", "content", "prefixCls", "onConfirm"]);

      var handleConfirmClick = function handleConfirmClick() {
        update({
          visible: false
        });

        if (typeof props.onConfirm === 'function') {
          props.onConfirm();
        }
      };

      var handleCancelClick = function handleCancelClick() {
        update({
          visible: false
        });

        if (typeof props.onCancel === 'function') {
          props.onCancel();
        }
      };

      var iconType = {
        success: 'check-circle',
        error: 'x-circle',
        warning: 'alert-circle',
        info: 'info',
        confirm: 'help-circle'
      };
      var contentNode = React.createElement("div", {
        className: prefixCls + "-body-container"
      }, React.createElement("span", {
        className: prefixCls + "-body-title"
      }, title), React.createElement("div", {
        className: prefixCls + "-body-content"
      }, content), React.createElement(_icon["default"], {
        className: classNames(prefixCls + "-body-icon", (_classNames = {}, _classNames[prefixCls + "-body-icon-" + type] = true, _classNames)),
        type: iconType[type]
      }));
      return React.createElement(_panel["default"], (0, _extends2["default"])({}, attributes, {
        showFooter: false,
        onClose: destroy
      }), contentNode, React.createElement("div", {
        className: prefixCls + "-body-btn"
      }, type === 'confirm' && React.createElement(_button["default"], {
        onClick: handleCancelClick,
        className: prefixCls + "-body-btn-cancel"
      }, "Cancel"), React.createElement(_button["default"], {
        type: "primary",
        onClick: handleConfirmClick
      }, "OK")));
    }

    return {
      destroy: destroy,
      update: update
    };
  };
}