"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = void 0;

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inheritsLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/inheritsLoose"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var React = _interopRequireWildcard(require("react"));

var classNames = _interopRequireWildcard(require("classnames"));

var _reactTransitionGroup = require("react-transition-group");

var _icon = _interopRequireDefault(require("../icon"));

var _button = _interopRequireDefault(require("../button"));

var ESC_KEY = 27;

var ModalPanel =
/*#__PURE__*/
function (_React$Component) {
  (0, _inheritsLoose2["default"])(ModalPanel, _React$Component);

  function ModalPanel(props) {
    var _this;

    _this = _React$Component.call(this, props) || this;
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "bodyRef", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "openModal", function () {
      _this.setState({
        visible: true
      }, function () {
        _this.setState({
          bodyVisible: true
        });
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "closeModal", function () {
      _this.setState({
        bodyVisible: false
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleClose", function () {
      _this.closeModal();
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleExited", function () {
      var onClose = _this.props.onClose;

      _this.setState({
        visible: false
      });

      if (typeof onClose === 'function') {
        onClose();
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "focusBody", function () {
      var bodyElement = _this.bodyRef.current;

      if (bodyElement) {
        bodyElement.focus();
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleKeydown", function (event) {
      if (event.keyCode === ESC_KEY) {
        event.stopPropagation();

        _this.closeModal();
      }
    });
    _this.state = {
      visible: false,
      bodyVisible: false
    };
    _this.bodyRef = React.createRef();
    return _this;
  }

  var _proto = ModalPanel.prototype;

  _proto.componentDidUpdate = function componentDidUpdate(prevProps, prevState) {
    var _this2 = this;

    if (this.props.visible && !prevProps.visible) {
      this.openModal();
    } else if (!this.props.visible && prevProps.visible) {
      this.closeModal();
    }

    if (this.state.visible && !prevState.visible) {
      setTimeout(function () {
        _this2.focusBody();
      }, 0);
    }
  };

  _proto.render = function render() {
    if (!this.state.visible) {
      return null;
    }

    var _this$props = this.props,
        prefixCls = _this$props.prefixCls,
        showFooter = _this$props.showFooter,
        footer = _this$props.footer,
        closeByEsc = _this$props.closeByEsc,
        title = _this$props.title,
        className = _this$props.className,
        width = _this$props.width,
        children = _this$props.children;
    var footerNode = React.createElement(React.Fragment, null, React.createElement(_button["default"], {
      type: "default",
      onClick: this.props.onCancel
    }, "Cancel"), React.createElement(_button["default"], {
      type: "primary",
      className: prefixCls + "-footer-confirm",
      onClick: this.props.onConfirm
    }, "OK"));
    var bodyNode = React.createElement(_reactTransitionGroup.CSSTransition, {
      "in": this.state.bodyVisible,
      unmountOnExit: true,
      timeout: 300,
      classNames: prefixCls + "-panel",
      onExited: this.handleExited
    }, React.createElement("div", {
      className: classNames(prefixCls + "-panel", className),
      onKeyDown: closeByEsc ? this.handleKeydown : undefined,
      tabIndex: -1,
      ref: this.bodyRef,
      style: width !== undefined ? {
        width: width
      } : null
    }, !!title && React.createElement(React.Fragment, null, React.createElement("div", {
      className: prefixCls + "-header"
    }, title), React.createElement("div", {
      className: prefixCls + "-close",
      onClick: this.handleClose
    }, React.createElement(_icon["default"], {
      className: prefixCls + "-close-icon",
      type: "x"
    }))), React.createElement("div", {
      className: prefixCls + "-body"
    }, children), !!showFooter && React.createElement("div", {
      className: prefixCls + "-footer"
    }, footer === undefined ? footerNode : footer)));
    return React.createElement("div", {
      className: "" + prefixCls
    }, React.createElement(_reactTransitionGroup.CSSTransition, {
      timeout: 300,
      "in": this.state.bodyVisible,
      classNames: prefixCls + "-mask"
    }, React.createElement("div", {
      className: prefixCls + "-mask",
      onClick: this.handleClose
    })), bodyNode);
  };

  return ModalPanel;
}(React.Component);

(0, _defineProperty2["default"])(ModalPanel, "defaultProps", {
  prefixCls: 'dk-modal',
  closeByEsc: true,
  showFooter: true
});
(0, _defineProperty2["default"])(ModalPanel, "success", void 0);
var _default = ModalPanel;
exports["default"] = _default;