"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var React = _interopRequireWildcard(require("react"));

var enzyme = _interopRequireWildcard(require("enzyme"));

var _ = _interopRequireDefault(require(".."));

var prefixCls = 'dk-pagination';
describe('Pagination[Basic]', function () {
  test('should call onChange', function () {
    var changeMock = jest.fn();
    var wrapper = enzyme.mount(React.createElement(_["default"], {
      current: 10,
      total: 1000,
      onChange: changeMock
    }));
    wrapper.find("." + prefixCls + "-item").first().simulate('click');
    expect(changeMock.mock.calls[0][0]).toBe(1);
  });
  test('should disabled items', function () {
    var wrapper = enzyme.mount(React.createElement(_["default"], {
      current: 1,
      total: 2,
      disabled: true
    }));
    wrapper.find(prefixCls + "-item").forEach(function (item) {
      expect(item.prop('disabled')).toBeTruthy();
    });
  });
  test('should minus while prev click', function () {
    var wrapper = enzyme.mount(React.createElement(_["default"], {
      current: 10,
      total: 1000
    }));
    wrapper.find("." + prefixCls + "-prev").first().simulate('click');
    wrapper.update();
    setTimeout(function () {
      expect(wrapper.state('current')).toBe(9);
    }, 0);
  });
  test('should add while next click', function () {
    var wrapper = enzyme.mount(React.createElement(_["default"], {
      current: 10,
      total: 1000
    }));
    wrapper.find("." + prefixCls + "-next").first().simulate('click');
    setTimeout(function () {
      expect(wrapper.state('current')).toBe(11);
    }, 0);
  });
});