"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inheritsLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/inheritsLoose"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var React = _interopRequireWildcard(require("react"));

var classNames = _interopRequireWildcard(require("classnames"));

var _lodashEs = require("lodash-es");

var _context = require("../checkbox/context");

var RadioGroup =
/*#__PURE__*/
function (_React$PureComponent) {
  (0, _inheritsLoose2["default"])(RadioGroup, _React$PureComponent);

  RadioGroup.getDerivedStateFromProps = function getDerivedStateFromProps(nextProps, prevState) {
    if (!(0, _lodashEs.isEqual)(nextProps.value, prevState.value)) {
      return {
        value: nextProps.value
      };
    }

    return null;
  };

  function RadioGroup(props) {
    var _this;

    _this = _React$PureComponent.call(this, props) || this;
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleRawChange", function (checked, value) {
      var onChange = _this.props.onChange;

      _this.setState({
        value: value
      });

      if (typeof onChange === 'function') {
        onChange(value);
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleChecked", function (value) {
      return value === _this.state.value;
    });

    var _value = props.defaultValue || props.value;

    _this.state = {
      value: _value
    };
    return _this;
  }

  var _proto = RadioGroup.prototype;

  _proto.render = function render() {
    var _classNames;

    var _this$props = this.props,
        className = _this$props.className,
        prefixCls = _this$props.prefixCls,
        children = _this$props.children,
        onChange = _this$props.onChange,
        value = _this$props.value,
        defaultValue = _this$props.defaultValue,
        attibutes = (0, _objectWithoutPropertiesLoose2["default"])(_this$props, ["className", "prefixCls", "children", "onChange", "value", "defaultValue"]);
    var groupClassName = classNames((_classNames = {}, _classNames[prefixCls + "-group"] = true, _classNames), className);
    return React.createElement("div", (0, _extends2["default"])({
      className: groupClassName
    }, attibutes), React.createElement(_context.Provider, {
      value: {
        onRawChange: this.handleRawChange,
        checked: this.handleChecked
      }
    }, children));
  };

  return RadioGroup;
}(React.PureComponent);

(0, _defineProperty2["default"])(RadioGroup, "componentType", 'RadioGroup');
(0, _defineProperty2["default"])(RadioGroup, "defaultProps", {
  prefixCls: 'dk-radio'
});
var _default = RadioGroup;
exports["default"] = _default;