"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = void 0;

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inheritsLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/inheritsLoose"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var React = _interopRequireWildcard(require("react"));

var classNames = _interopRequireWildcard(require("classnames"));

var _utils = require("./utils");

var Scrollbar =
/*#__PURE__*/
function (_React$PureComponent) {
  (0, _inheritsLoose2["default"])(Scrollbar, _React$PureComponent);

  function Scrollbar(props) {
    var _this;

    _this = _React$PureComponent.call(this, props) || this;
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "scrolling", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "dragging", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "prevPageY", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "prevPageX", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "viewScrollLeft", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "viewScrollTop", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "lastViewScrollLeft", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "lastViewScrollTop", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "hideTracksTimeout", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "detectScrollingInterval", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "trackMouseOver", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "requestFrame", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "containerRef", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "trackHorizontalRef", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "thumbHorizontalRef", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "trackVerticalRef", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "thumbVerticalRef", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "viewRef", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "getScrollLeft", function () {
      var el = _this.viewRef.current;

      if (!el) {
        return 0;
      }

      return el.scrollLeft;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "getScrollTop", function () {
      var el = _this.viewRef.current;

      if (!el) {
        return 0;
      }

      return el.scrollTop;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "getScrollWidth", function () {
      var el = _this.viewRef.current;

      if (!el) {
        return 0;
      }

      return el.scrollWidth;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "getScrollHeight", function () {
      var el = _this.viewRef.current;

      if (!el) {
        return 0;
      }

      return el.scrollHeight;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "getClientWidth", function () {
      var el = _this.viewRef.current;

      if (!el) {
        return 0;
      }

      return el.clientWidth;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "getClientHeight", function () {
      var el = _this.viewRef.current;

      if (!el) {
        return 0;
      }

      return el.clientHeight;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "getValues", function () {
      var _ref = _this.viewRef.current || {},
          _ref$scrollLeft = _ref.scrollLeft,
          scrollLeft = _ref$scrollLeft === void 0 ? 0 : _ref$scrollLeft,
          _ref$scrollTop = _ref.scrollTop,
          scrollTop = _ref$scrollTop === void 0 ? 0 : _ref$scrollTop,
          _ref$scrollWidth = _ref.scrollWidth,
          scrollWidth = _ref$scrollWidth === void 0 ? 0 : _ref$scrollWidth,
          _ref$scrollHeight = _ref.scrollHeight,
          scrollHeight = _ref$scrollHeight === void 0 ? 0 : _ref$scrollHeight,
          _ref$clientWidth = _ref.clientWidth,
          clientWidth = _ref$clientWidth === void 0 ? 0 : _ref$clientWidth,
          _ref$clientHeight = _ref.clientHeight,
          clientHeight = _ref$clientHeight === void 0 ? 0 : _ref$clientHeight;

      return {
        left: scrollLeft / (scrollWidth - clientWidth) || 0,
        top: scrollTop / (scrollHeight - clientHeight) || 0,
        scrollLeft: scrollLeft,
        scrollTop: scrollTop,
        scrollWidth: scrollWidth,
        scrollHeight: scrollHeight,
        clientWidth: clientWidth,
        clientHeight: clientHeight
      };
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "getThumbHorizontalWidth", function () {
      var _this$props = _this.props,
          thumbSize = _this$props.thumbSize,
          thumbMinSize = _this$props.thumbMinSize;
      var _ref2 = _this.viewRef.current,
          scrollWidth = _ref2.scrollWidth,
          clientWidth = _ref2.clientWidth;
      var trackHorizontalDiv = _this.trackHorizontalRef.current;
      var trackWidth = (0, _utils.getInnerWidth)(trackHorizontalDiv);
      var width = Math.ceil(clientWidth / scrollWidth * trackWidth);

      if (trackWidth === width) {
        return 0;
      }

      if (thumbSize) {
        return thumbSize;
      }

      return Math.max(width, thumbMinSize);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "getThumbVerticalHeight", function () {
      var _this$props2 = _this.props,
          thumbSize = _this$props2.thumbSize,
          thumbMinSize = _this$props2.thumbMinSize;
      var _ref3 = _this.viewRef.current,
          scrollHeight = _ref3.scrollHeight,
          clientHeight = _ref3.clientHeight;
      var trackVerticalDiv = _this.trackVerticalRef.current;
      var trackHeight = (0, _utils.getInnerHeight)(trackVerticalDiv);
      var height = Math.ceil(clientHeight / scrollHeight * trackHeight);

      if (trackHeight === height) {
        return 0;
      }

      if (thumbSize) {
        return thumbSize;
      }

      return Math.max(height, thumbMinSize);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "getScrollLeftForOffset", function (offset) {
      var _ref4 = _this.viewRef.current,
          scrollWidth = _ref4.scrollWidth,
          clientWidth = _ref4.clientWidth;
      var trackHorizontalDiv = _this.trackHorizontalRef.current;
      var trackWidth = (0, _utils.getInnerWidth)(trackHorizontalDiv);

      var thumbWidth = _this.getThumbHorizontalWidth();

      return offset / (trackWidth - thumbWidth) * (scrollWidth - clientWidth);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "getScrollTopForOffset", function (offset) {
      var _ref5 = _this.viewRef.current,
          scrollHeight = _ref5.scrollHeight,
          clientHeight = _ref5.clientHeight;
      var trackVerticalDiv = _this.trackVerticalRef.current;
      var trackHeight = (0, _utils.getInnerHeight)(trackVerticalDiv);

      var thumbHeight = _this.getThumbVerticalHeight();

      return offset / (trackHeight - thumbHeight) * (scrollHeight - clientHeight);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "scrollLeft", function (left, duration) {
      if (left === void 0) {
        left = 0;
      }

      if (duration === void 0) {
        duration = 0;
      }

      if (!_this.viewRef.current) {
        return;
      }

      if (duration === 0) {
        _this.viewRef.current.scrollLeft = left;
      } else {
        scrollAnimateLeft(_this.viewRef.current, left, duration);
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "scrollTop", function (top, duration) {
      if (top === void 0) {
        top = 0;
      }

      if (duration === void 0) {
        duration = 0;
      }

      if (!_this.viewRef.current) {
        return;
      }

      if (duration === 0) {
        _this.viewRef.current.scrollTop = top;
      } else {
        scrollAnimateTop(_this.viewRef.current, top, duration);
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "scrollToLeft", function () {
      if (!_this.viewRef.current) {
        return;
      }

      _this.viewRef.current.scrollLeft = 0;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "scrollToTop", function () {
      if (!_this.viewRef.current) {
        return;
      }

      _this.viewRef.current.scrollTop = 0;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "scrollToRight", function () {
      if (!_this.viewRef.current) {
        return;
      }

      _this.viewRef.current.scrollLeft = _this.viewRef.current.scrollWidth;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "scrollToBottom", function () {
      if (!_this.viewRef.current) {
        return;
      }

      _this.viewRef.current.scrollTop = _this.viewRef.current.scrollHeight;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "addListeners", function () {
      if (typeof document === 'undefined' || !_this.viewRef.current) {
        return;
      }

      _this.viewRef.current.addEventListener('scroll', _this.handleScroll);

      if (!_this.props.autoHide) {
        return;
      }

      var trackHorizontalDiv = _this.trackHorizontalRef.current;
      var trackVerticalDiv = _this.trackVerticalRef.current;
      var thumbHorizontalDiv = _this.thumbHorizontalRef.current;
      var thumbVerticalDiv = _this.thumbVerticalRef.current;
      trackHorizontalDiv.addEventListener('mousedown', _this.handleHorizontalTrackMouseDown);
      trackVerticalDiv.addEventListener('mousedown', _this.handleVerticalTrackMouseDown);
      thumbHorizontalDiv.addEventListener('mousedown', _this.handleHorizontalThumbMouseDown);
      thumbVerticalDiv.addEventListener('mousedown', _this.handleVerticalThumbMouseDown);
      window.addEventListener('resize', _this.handleWindowResize);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "removeListeners", function () {
      if (typeof document === 'undefined' || !_this.viewRef.current) {
        return;
      }

      _this.viewRef.current.removeEventListener('scroll', _this.handleScroll);

      if (!_this.props.autoHide) {
        return;
      }

      var trackHorizontalDiv = _this.trackHorizontalRef.current;
      var trackVerticalDiv = _this.trackVerticalRef.current;
      var thumbHorizontalDiv = _this.thumbHorizontalRef.current;
      var thumbVerticalDiv = _this.thumbVerticalRef.current;
      trackHorizontalDiv.removeEventListener('mousedown', _this.handleHorizontalTrackMouseDown);
      trackVerticalDiv.removeEventListener('mousedown', _this.handleVerticalTrackMouseDown);
      thumbHorizontalDiv.removeEventListener('mousedown', _this.handleHorizontalThumbMouseDown);
      thumbVerticalDiv.removeEventListener('mousedown', _this.handleVerticalThumbMouseDown);
      window.removeEventListener('resize', _this.handleWindowResize);

      _this.teardownDragging();
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleScroll", function (event) {
      var _this$props3 = _this.props,
          onScroll = _this$props3.onScroll,
          onScrollFrame = _this$props3.onScrollFrame;

      if (typeof onScroll === 'function') {
        onScroll(event);
      }

      _this.update(function (values) {
        var scrollLeft = values.scrollLeft,
            scrollTop = values.scrollTop;
        _this.viewScrollLeft = scrollLeft;
        _this.viewScrollTop = scrollTop;

        if (typeof onScrollFrame === 'function') {
          onScrollFrame(values);
        }
      });

      _this.detectScrolling();
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleScrollStart", function () {
      var onScrollStart = _this.props.onScrollStart;

      if (typeof onScrollStart === 'function') {
        onScrollStart();
      }

      _this.handleScrollStartAutoHide();
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleScrollStartAutoHide", function () {
      var autoHide = _this.props.autoHide;

      if (!autoHide) {
        return;
      }

      _this.showTracks();
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleScrollStop", function () {
      var onScrollStop = _this.props.onScrollStop;

      if (typeof onScrollStop === 'function') {
        onScrollStop();
      }

      _this.handleScrollStopAutoHide();
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleScrollStopAutoHide", function () {
      var autoHide = _this.props.autoHide;

      if (!autoHide) {
        return;
      }

      _this.hideTracks();
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleWindowResize", function () {
      _this.update();
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleHorizontalTrackMouseDown", function (event) {
      event.preventDefault();
      var target = event.target,
          clientX = event.clientX;

      var _target$getBoundingCl = target.getBoundingClientRect(),
          targetLeft = _target$getBoundingCl.left;

      var thumbWidth = _this.getThumbHorizontalWidth();

      var offset = Math.abs(targetLeft - clientX) - thumbWidth / 2;
      var viewDiv = _this.viewRef.current;
      viewDiv.scrollLeft = _this.getScrollLeftForOffset(offset);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleVerticalTrackMouseDown", function (event) {
      event.preventDefault();
      var target = event.target,
          clientY = event.clientY;

      var _target$getBoundingCl2 = target.getBoundingClientRect(),
          targetTop = _target$getBoundingCl2.top;

      var thumbHeight = _this.getThumbVerticalHeight();

      var offset = Math.abs(targetTop - clientY) - thumbHeight / 2;
      var viewDiv = _this.viewRef.current;
      viewDiv.scrollTop = _this.getScrollTopForOffset(offset);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleHorizontalThumbMouseDown", function (event) {
      event.preventDefault();

      _this.handleDragStart(event);

      var target = event.target,
          clientX = event.clientX;
      var offsetWidth = target.offsetWidth;

      var _target$getBoundingCl3 = target.getBoundingClientRect(),
          left = _target$getBoundingCl3.left;

      _this.prevPageX = offsetWidth - (clientX - left);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleVerticalThumbMouseDown", function (event) {
      event.preventDefault();

      _this.handleDragStart(event);

      var target = event.target,
          clientY = event.clientY;
      var offsetHeight = target.offsetHeight;

      var _target$getBoundingCl4 = target.getBoundingClientRect(),
          top = _target$getBoundingCl4.top;

      _this.prevPageY = offsetHeight - (clientY - top);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "setupDragging", function () {
      var doc = document;
      doc.body.style.userSelect = 'none';
      doc.addEventListener('mousemove', _this.handleDrag);
      doc.addEventListener('mouseup', _this.handleDragEnd);

      doc.onselectstart = function () {
        return false;
      };
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "teardownDragging", function () {
      var doc = document;
      doc.body.style.userSelect = '';
      doc.removeEventListener('mousemove', _this.handleDrag);
      doc.removeEventListener('mouseup', _this.handleDragEnd);
      doc.onselectstart = undefined;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleDragStart", function (event) {
      _this.dragging = true;
      event.stopImmediatePropagation();

      _this.setupDragging();
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleDrag", function (event) {
      if (_this.prevPageX) {
        var clientX = event.clientX;
        var trackHorizontalDiv = _this.trackHorizontalRef.current;
        var viewDiv = _this.viewRef.current;

        var _trackHorizontalDiv$g = trackHorizontalDiv.getBoundingClientRect(),
            trackLeft = _trackHorizontalDiv$g.left;

        var thumbWidth = _this.getThumbHorizontalWidth();

        var clickPosition = thumbWidth - _this.prevPageX;
        var offset = -trackLeft + clientX - clickPosition;
        viewDiv.scrollLeft = _this.getScrollLeftForOffset(offset);
      }

      if (_this.prevPageY) {
        var clientY = event.clientY;
        var trackVerticalDiv = _this.trackVerticalRef.current;
        var _viewDiv = _this.viewRef.current;

        var _trackVerticalDiv$get = trackVerticalDiv.getBoundingClientRect(),
            trackTop = _trackVerticalDiv$get.top;

        var thumbHeight = _this.getThumbVerticalHeight();

        var _clickPosition = thumbHeight - _this.prevPageY;

        var _offset = -trackTop + clientY - _clickPosition;

        _viewDiv.scrollTop = _this.getScrollTopForOffset(_offset);
      }

      return false;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleDragEnd", function () {
      _this.dragging = false;
      _this.prevPageX = _this.prevPageY = 0;

      _this.teardownDragging();

      _this.handleDragEndAutoHide();
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleDragEndAutoHide", function () {
      var autoHide = _this.props.autoHide;

      if (!autoHide) {
        return;
      }

      _this.hideTracks();
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleTrackMouseEnter", function () {
      _this.trackMouseOver = true;

      _this.handleTrackMouseEnterAutoHide();
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleTrackMouseEnterAutoHide", function () {
      var autoHide = _this.props.autoHide;

      if (!autoHide) {
        return;
      }

      _this.showTracks();
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleTrackMouseLeave", function () {
      _this.trackMouseOver = false;

      _this.handleTrackMouseLeaveAutoHide();
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleTrackMouseLeaveAutoHide", function () {
      var autoHide = _this.props.autoHide;

      if (!autoHide) {
        return;
      }

      _this.hideTracks();
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "showTracks", function () {
      clearTimeout(_this.hideTracksTimeout);
      var trackHorizontalDiv = _this.trackHorizontalRef.current;
      var trackVerticalDiv = _this.trackVerticalRef.current;
      trackHorizontalDiv.style.opacity = '1';
      trackVerticalDiv.style.opacity = '1';
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "hideTracks", function () {
      if (_this.dragging) {
        return;
      }

      if (_this.scrolling) {
        return;
      }

      if (_this.trackMouseOver) {
        return;
      }

      var autoHideTimeout = _this.props.autoHideTimeout;
      clearTimeout(_this.hideTracksTimeout);
      _this.hideTracksTimeout = window.setTimeout(function () {
        var trackHorizontalDiv = _this.trackHorizontalRef.current;
        var trackVerticalDiv = _this.trackVerticalRef.current;
        trackHorizontalDiv.style.opacity = '0';
        trackVerticalDiv.style.opacity = '0';
      }, autoHideTimeout);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "detectScrolling", function () {
      if (_this.scrolling) {
        return;
      }

      _this.scrolling = true;

      _this.handleScrollStart();

      _this.detectScrollingInterval = window.setInterval(function () {
        if (_this.lastViewScrollLeft === _this.viewScrollLeft && _this.lastViewScrollTop === _this.viewScrollTop) {
          clearInterval(_this.detectScrollingInterval);
          _this.scrolling = false;

          _this.handleScrollStop();
        }

        _this.lastViewScrollLeft = _this.viewScrollLeft;
        _this.lastViewScrollTop = _this.viewScrollTop;
      }, 100);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "raf", function (callback) {
      if (_this.requestFrame) {
        (0, _utils.caf)(_this.requestFrame);
      }

      _this.requestFrame = (0, _utils.raf)(function () {
        _this.requestFrame = undefined;
        callback();
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "update", function (callback) {
      _this.raf(function () {
        return _this.updateCallback(callback);
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "updateCallback", function (callback) {
      var onUpdate = _this.props.onUpdate;

      var values = _this.getValues();

      var scrollLeft = values.scrollLeft,
          clientWidth = values.clientWidth,
          scrollWidth = values.scrollWidth;

      if (_this.props.autoHide) {
        var trackHorizontalDiv = _this.trackHorizontalRef.current;
        var trackHorizontalWidth = (0, _utils.getInnerWidth)(trackHorizontalDiv);

        var thumbHorizontalWidth = _this.getThumbHorizontalWidth();

        var thumbHorizontalX = scrollLeft / (scrollWidth - clientWidth) * (trackHorizontalWidth - thumbHorizontalWidth);
        var scrollTop = values.scrollTop,
            clientHeight = values.clientHeight,
            scrollHeight = values.scrollHeight;
        var trackVerticalDiv = _this.trackVerticalRef.current;
        var trackVerticalHeight = (0, _utils.getInnerHeight)(trackVerticalDiv);

        var thumbVerticalHeight = _this.getThumbVerticalHeight();

        var thumbVerticalY = scrollTop / (scrollHeight - clientHeight) * (trackVerticalHeight - thumbVerticalHeight);
        var thumbHorizontalDiv = _this.thumbHorizontalRef.current;
        var thumbVerticalDiv = _this.thumbVerticalRef.current;
        thumbHorizontalDiv.style.height = thumbHorizontalWidth + "px";
        thumbHorizontalDiv.style.transform = "translateX(" + thumbHorizontalX + "px)";
        thumbVerticalDiv.style.height = thumbVerticalHeight + "px";
        thumbVerticalDiv.style.transform = "translateY(" + thumbVerticalY + "px)";
      }

      if (typeof onUpdate === 'function') {
        onUpdate(values);
      }

      if (typeof callback === 'function') {
        callback(values);
      }
    });
    _this.hideTracksTimeout = 0;
    _this.detectScrollingInterval = 0;
    _this.scrolling = false;
    _this.dragging = false;
    _this.containerRef = React.createRef();
    _this.viewRef = React.createRef();
    _this.trackHorizontalRef = React.createRef();
    _this.thumbHorizontalRef = React.createRef();
    _this.trackVerticalRef = React.createRef();
    _this.thumbVerticalRef = React.createRef();
    return _this;
  }

  var _proto = Scrollbar.prototype;

  _proto.componentDidMount = function componentDidMount() {
    this.addListeners();
    this.update();
  };

  _proto.componentDidUpdate = function componentDidUpdate(prevProps) {
    if (prevProps.autoHide !== this.props.autoHide) {
      this.removeListeners();
      this.addListeners();
    } // this.update();

  };

  _proto.componentWillUnmount = function componentWillUnmount() {
    this.removeListeners();

    if (this.requestFrame) {
      (0, _utils.caf)(this.requestFrame);
    }

    clearTimeout(this.hideTracksTimeout);
    clearInterval(this.detectScrollingInterval);
  };

  _proto.render = function render() {
    var _classNames, _classNames2, _classNames3;

    var _this$props4 = this.props,
        prefixCls = _this$props4.prefixCls,
        children = _this$props4.children,
        style = _this$props4.style,
        className = _this$props4.className,
        autoHide = _this$props4.autoHide;
    var containerClassName = classNames((_classNames = {}, _classNames["" + prefixCls] = true, _classNames), className);
    var scrollbarWidth = (0, _utils.getScrollbarWidth)();
    var viewStyle = {
      marginLeft: "-" + scrollbarWidth + "px",
      marginRight: "-" + scrollbarWidth + "px"
    };
    return React.createElement("div", {
      className: containerClassName,
      ref: this.containerRef,
      style: style
    }, React.createElement("div", {
      className: prefixCls + "-view",
      ref: this.viewRef,
      style: viewStyle
    }, children), React.createElement("div", {
      className: classNames((_classNames2 = {}, _classNames2[prefixCls + "-track-horizontal"] = true, _classNames2[prefixCls + "-hide-track"] = autoHide, _classNames2)),
      ref: this.trackHorizontalRef
    }, React.createElement("div", {
      className: prefixCls + "-thumb-horizontal",
      ref: this.thumbHorizontalRef
    })), React.createElement("div", {
      className: classNames((_classNames3 = {}, _classNames3[prefixCls + "-track-vertical"] = true, _classNames3[prefixCls + "-hide-track"] = autoHide, _classNames3)),
      ref: this.trackVerticalRef
    }, React.createElement("div", {
      className: prefixCls + "-thumb-vertical",
      ref: this.thumbVerticalRef
    })));
  };

  return Scrollbar;
}(React.PureComponent);

(0, _defineProperty2["default"])(Scrollbar, "defaultProps", {
  prefixCls: 'dk-scrollbar',
  thumbMinSize: 30,
  autoHide: true,
  autoHideTimeout: 1000
});

var scrollAnimateTop = function scrollAnimateTop(element, to, duration) {
  if (duration <= 0) {
    element.scrollTop = to;
    return;
  }

  var difference = to - element.scrollTop;
  var perTick = difference / duration * 10;
  (0, _utils.raf)(function () {
    element.scrollTop = element.scrollTop + perTick;

    if (element.scrollTop === to) {
      return;
    }

    scrollAnimateTop(element, to, duration - 10);
  });
};

var scrollAnimateLeft = function scrollAnimateLeft(element, to, duration) {
  if (duration <= 0) {
    element.scrollLeft = to;
    return;
  }

  var difference = to - element.scrollLeft;
  var perTick = difference / duration * 10;
  (0, _utils.raf)(function () {
    element.scrollLeft = element.scrollLeft + perTick;

    if (element.scrollLeft === to) {
      return;
    }

    scrollAnimateLeft(element, to, duration - 10);
  });
};

var _default = Scrollbar;
exports["default"] = _default;