"use strict";

exports.__esModule = true;
exports.getInnerWidth = getInnerWidth;
exports.getInnerHeight = getInnerHeight;
exports.getScrollbarWidth = getScrollbarWidth;
exports.caf = exports.raf = void 0;

function getInnerWidth(el) {
  var clientWidth = el.clientWidth;

  var _getComputedStyle = getComputedStyle(el),
      paddingLeft = _getComputedStyle.paddingLeft,
      paddingRight = _getComputedStyle.paddingRight;

  return clientWidth - (paddingLeft ? parseFloat(paddingLeft) : 0) - (paddingRight ? parseFloat(paddingRight) : 0);
}

function getInnerHeight(el) {
  var clientHeight = el.clientHeight;

  var _getComputedStyle2 = getComputedStyle(el),
      paddingTop = _getComputedStyle2.paddingTop,
      paddingBottom = _getComputedStyle2.paddingBottom;

  return clientHeight - (paddingTop ? parseFloat(paddingTop) : 0) - (paddingBottom ? parseFloat(paddingBottom) : 0);
}

var scrollbarWidth;

function getScrollbarWidth() {
  if (!scrollbarWidth) {
    return 0;
  }

  var div = document.createElement('div');
  div.setAttribute('style', 'display:block;position:absolute;width:100px;height:100px;top:-9999px;overflow:scroll;');
  document.body.appendChild(div);
  scrollbarWidth = div.offsetWidth - div.clientWidth;
  document.body.removeChild(div);
  return scrollbarWidth || 0;
}

var raf = window.requestAnimationFrame || function requestAnimationFrameTimeout() {
  return setTimeout(arguments[0], 10);
};

exports.raf = raf;
var caf = window.cancelAnimationFrame;
exports.caf = caf;