"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inheritsLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/inheritsLoose"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var React = _interopRequireWildcard(require("react"));

var _reactDom = require("react-dom");

var _reactTransitionGroup = require("react-transition-group");

var classNames = _interopRequireWildcard(require("classnames"));

var _context = require("./context");

var _input = _interopRequireDefault(require("../input"));

var Select =
/*#__PURE__*/
function (_React$PureComponent) {
  (0, _inheritsLoose2["default"])(Select, _React$PureComponent);

  Select.getDerivedStateFromProps = function getDerivedStateFromProps(nextProps) {
    if ('value' in nextProps) {
      if (nextProps.value === undefined) {
        return {
          inputValue: '',
          value: nextProps.value,
          options: nextProps.multiple ? [] : ''
        };
      }

      return {
        value: nextProps.value
      };
    }

    return null;
  };

  function Select(props) {
    var _this;

    _this = _React$PureComponent.call(this, props) || this;
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "selectElement", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "panelElement", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "bindDocumentClick", function () {
      document.addEventListener('click', _this.handleDocumentClick);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "clearDocumentClick", function () {
      document.removeEventListener('click', _this.handleDocumentClick);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleExited", function () {
      _this.clearDocumentClick();
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleDocumentClick", function (event) {
      var el = (0, _reactDom.findDOMNode)(_this.selectElement.current);
      var contentEl = _this.panelElement.current;
      var targetEl = event.target;

      if (!(targetEl === el || el && el.contains(targetEl) || targetEl === contentEl || contentEl && contentEl.contains(targetEl))) {
        var options = _this.state.options;

        _this.setState({
          visible: false,
          inputValue: options instanceof Array ? '' : options.toString()
        });
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "getPosition", function () {
      var el = (0, _reactDom.findDOMNode)(_this.selectElement.current);
      var rect = el.getBoundingClientRect();
      var scrollTop = document.documentElement.scrollTop || document.body.scrollTop;
      var scrollLeft = document.documentElement.scrollLeft || document.body.scrollLeft;
      var left = scrollLeft + rect.left;
      var top = scrollTop + rect.top + rect.height;
      return {
        left: left,
        top: top
      };
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleEnter", function () {
      var position = _this.getPosition();

      var el = (0, _reactDom.findDOMNode)(_this.selectElement.current);
      var width = el.clientWidth || 0;

      _this.setState({
        position: position,
        width: width
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleInputFocus", function () {
      _this.setState({
        visible: true,
        inputValue: ''
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleInputChange", function (value) {
      _this.setState({
        inputValue: value
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleRawChange", function (value) {
      var options = _this.state.options;
      var onChange = _this.props.onChange;
      var newOptions = options instanceof Array ? Array.from(new Set([].concat(options, [value]))) : value;
      var newInputValue = newOptions instanceof Array ? '' : value;

      _this.setState({
        options: newOptions,
        inputValue: newInputValue,
        visible: false
      });

      if (typeof onChange === 'function') {
        onChange(newOptions);
      }
    });
    _this.selectElement = React.createRef();
    _this.panelElement = React.createRef();
    _this.state = {
      visible: false,
      options: props.multiple ? [] : props.defaultValue || '',
      inputValue: props.defaultValue ? props.defaultValue.toString() : '',
      width: 0,
      position: {
        top: 0,
        left: 0
      }
    };
    return _this;
  }

  var _proto = Select.prototype;

  _proto.render = function render() {
    var _classNames;

    var _this$props = this.props,
        prefixCls = _this$props.prefixCls,
        size = _this$props.size,
        children = _this$props.children,
        disabled = _this$props.disabled,
        value = _this$props.value,
        multiple = _this$props.multiple,
        onChange = _this$props.onChange,
        prefix = _this$props.prefix,
        name = _this$props.name,
        prefixClassName = _this$props.prefixClassName,
        _this$props$placehold = _this$props.placeholder,
        placeholder = _this$props$placehold === void 0 ? 'Select' : _this$props$placehold,
        attributes = (0, _objectWithoutPropertiesLoose2["default"])(_this$props, ["prefixCls", "size", "children", "disabled", "value", "multiple", "onChange", "prefix", "name", "prefixClassName", "placeholder"]);
    var _this$state = this.state,
        position = _this$state.position,
        width = _this$state.width,
        options = _this$state.options,
        inputValue = _this$state.inputValue,
        visible = _this$state.visible;
    var iconClassName = classNames(prefixCls + "-icon", (_classNames = {}, _classNames[prefixCls + "-icon-visible"] = visible, _classNames));
    var panelStyle = (0, _extends2["default"])({}, position, {
      width: width
    });
    var selectNode = React.createElement(_reactTransitionGroup.CSSTransition, {
      "in": visible,
      unmountOnExit: true,
      timeout: 300,
      classNames: prefixCls + "-panel",
      onEntered: this.bindDocumentClick,
      onExited: this.clearDocumentClick,
      onEnter: this.handleEnter
    }, React.createElement("div", {
      className: prefixCls + "-panel",
      style: panelStyle,
      ref: this.panelElement
    }, React.createElement(_context.Provider, {
      value: {
        prefixCls: prefixCls,
        options: options,
        inputValue: inputValue,
        onRawChange: this.handleRawChange
      }
    }, children)));

    if (options instanceof Array) {
      return null;
    }

    return React.createElement(React.Fragment, null, React.createElement(_input["default"], {
      placeholder: options.toString() || placeholder,
      value: inputValue,
      disabled: disabled,
      size: size,
      name: name,
      onChange: this.handleInputChange,
      onFocus: this.handleInputFocus,
      prefix: prefix,
      prefixClassName: prefixClassName,
      suffix: "chevron-down",
      wrapperProps: (0, _extends2["default"])({}, attributes, {
        ref: this.selectElement
      }),
      suffixClassName: iconClassName
    }), !disabled && (0, _reactDom.createPortal)(selectNode, document.body));
  };

  return Select;
}(React.PureComponent);

(0, _defineProperty2["default"])(Select, "Option", void 0);
(0, _defineProperty2["default"])(Select, "OptionGroup", void 0);
(0, _defineProperty2["default"])(Select, "componentType", 'Select');
(0, _defineProperty2["default"])(Select, "defaultProps", {
  prefixCls: 'dk-select',
  size: 'default'
});
var _default = Select;
exports["default"] = _default;