"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = void 0;

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inheritsLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/inheritsLoose"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var classNames = _interopRequireWildcard(require("classnames"));

var React = _interopRequireWildcard(require("react"));

var _circle = _interopRequireDefault(require("./circle"));

var Spin =
/*#__PURE__*/
function (_React$Component) {
  (0, _inheritsLoose2["default"])(Spin, _React$Component);

  function Spin(props) {
    var _this;

    _this = _React$Component.call(this, props) || this;
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "delayTimeout", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "debounceTimeout", void 0);
    var spinning = props.spinning;
    _this.delayTimeout = 0;
    _this.debounceTimeout = 0;
    _this.state = {
      spinning: spinning
    };
    return _this;
  }

  var _proto = Spin.prototype;

  _proto.componentDidMount = function componentDidMount() {
    var _this2 = this;

    var _this$props = this.props,
        spinning = _this$props.spinning,
        delay = _this$props.delay;

    if (spinning && delay) {
      this.setState({
        spinning: false
      });
      this.delayTimeout = window.setTimeout(function () {
        _this2.setState({
          spinning: spinning
        });
      }, delay);
    }
  };

  _proto.componentWillReceiveProps = function componentWillReceiveProps(nextProps) {
    var _this3 = this;

    var currentSpinning = this.props.spinning;
    var spinning = nextProps.spinning;
    var delay = this.props.delay;

    if (this.debounceTimeout) {
      clearTimeout(this.debounceTimeout);
    }

    if (currentSpinning && !spinning) {
      this.debounceTimeout = window.setTimeout(function () {
        _this3.setState({
          spinning: spinning
        });
      }, 200);

      if (this.delayTimeout) {
        clearTimeout(this.delayTimeout);
      }
    } else {
      if (spinning && delay) {
        if (this.delayTimeout) {
          clearTimeout(this.delayTimeout);
        }

        this.delayTimeout = window.setTimeout(function () {
          _this3.setState({
            spinning: spinning
          });
        }, delay);
      } else {
        this.setState({
          spinning: spinning
        });
      }
    }
  };

  _proto.componentWillUnmount = function componentWillUnmount() {
    if (this.debounceTimeout) {
      clearTimeout(this.debounceTimeout);
    }

    if (this.delayTimeout) {
      window.clearTimeout(this.delayTimeout);
    }
  };

  _proto.render = function render() {
    var _ref;

    var _this$props2 = this.props,
        children = _this$props2.children,
        className = _this$props2.className,
        wrapperClassName = _this$props2.wrapperClassName,
        size = _this$props2.size,
        text = _this$props2.text,
        prefixCls = _this$props2.prefixCls;
    var spinning = this.state.spinning;
    var isNestedPattern = !!children;
    var spinClassName = classNames([prefixCls, (_ref = {}, _ref[prefixCls + "-spinning"] = spinning, _ref)]);
    var spinElement = React.createElement("div", {
      className: spinClassName
    }, React.createElement(_circle["default"], {
      prefixCls: prefixCls,
      size: size
    }), text ? React.createElement("div", {
      className: prefixCls + "-text"
    }, text) : null);

    if (isNestedPattern) {
      var _classNames;

      var containerClassName = classNames(prefixCls + "-container", (_classNames = {}, _classNames[prefixCls + "-blur"] = spinning, _classNames), className);
      return React.createElement("div", {
        className: classNames(prefixCls + "-box", wrapperClassName)
      }, React.createElement("div", {
        className: containerClassName
      }, children), spinning ? React.createElement("div", {
        className: prefixCls + "-loading"
      }, spinElement) : null);
    }

    return spinElement;
  };

  return Spin;
}(React.Component);

(0, _defineProperty2["default"])(Spin, "defaultProps", {
  prefixCls: 'dk-spin',
  spinning: true,
  size: 'default'
});
var _default = Spin;
exports["default"] = _default;