"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inheritsLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/inheritsLoose"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var classNames = _interopRequireWildcard(require("classnames"));

var React = _interopRequireWildcard(require("react"));

var Switch =
/*#__PURE__*/
function (_React$Component) {
  (0, _inheritsLoose2["default"])(Switch, _React$Component);

  function Switch(props) {
    var _this;

    _this = _React$Component.call(this, props) || this;
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "getChecked", function () {
      return 'checked' in _this.props ? _this.props.checked : _this.state.checked;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleChange", function () {
      var _this$props = _this.props,
          onChange = _this$props.onChange,
          onClick = _this$props.onClick;
      var checked = !_this.getChecked();

      _this.setState({
        checked: checked
      });

      if (typeof onChange === 'function') {
        onChange(checked);
      }

      if (typeof onClick === 'function') {
        onClick();
      }
    });
    _this.state = {
      checked: 'defaultChecked' in props ? props.defaultChecked : false
    };
    return _this;
  }

  var _proto = Switch.prototype;

  _proto.render = function render() {
    var _classNames;

    var _this$props2 = this.props,
        className = _this$props2.className,
        checkedChildren = _this$props2.checkedChildren,
        unCheckedChildren = _this$props2.unCheckedChildren,
        disabled = _this$props2.disabled,
        size = _this$props2.size,
        prefixCls = _this$props2.prefixCls,
        onClick = _this$props2.onClick,
        onChange = _this$props2.onChange,
        attributes = (0, _objectWithoutPropertiesLoose2["default"])(_this$props2, ["className", "checkedChildren", "unCheckedChildren", "disabled", "size", "prefixCls", "onClick", "onChange"]);
    var checked = this.getChecked();
    var switchClassName = classNames(prefixCls, (_classNames = {}, _classNames[prefixCls + "-checked"] = checked, _classNames[prefixCls + "-disabled"] = disabled, _classNames[prefixCls + "-small"] = size === 'small', _classNames[prefixCls + "-large"] = size === 'large', _classNames), className);
    return React.createElement("button", (0, _extends2["default"])({
      className: switchClassName,
      type: "button",
      onClick: this.handleChange
    }, attributes), React.createElement("span", {
      className: prefixCls + "-inner"
    }, checked ? checkedChildren : unCheckedChildren));
  };

  return Switch;
}(React.Component);

(0, _defineProperty2["default"])(Switch, "componentType", 'Switch');
(0, _defineProperty2["default"])(Switch, "defaultProps", {
  disabled: false,
  prefixCls: 'dk-switch',
  size: 'default'
});
var _default = Switch;
exports["default"] = _default;