import * as React from 'react';
export declare type TooltipPlacement = 'top-start' | 'top' | 'top-end' | 'right-start' | 'right' | 'right-end' | 'bottom-start' | 'bottom' | 'bottom-end' | 'left-start' | 'left' | 'left-end';
export declare type TooltipTrigger = 'hover' | 'click' | 'focus';
export declare type TooltipProps = {
    prefixCls?: string;
    className?: string;
    disabled?: boolean;
    trigger: TooltipTrigger;
    visible?: boolean;
    content: React.ReactNode;
    placement: TooltipPlacement;
};
export declare type TooltipState = {
    visible: boolean;
    left: number;
    top: number;
};
declare class Tooltip extends React.PureComponent<TooltipProps, TooltipState> {
    static defaultProps: {
        prefixCls: string;
        placement: TooltipPlacement;
        trigger: TooltipTrigger;
    };
    hoverTimer: number;
    readonly childRef: React.RefObject<HTMLDivElement>;
    readonly contentRef: React.RefObject<HTMLDivElement>;
    static getDerivedStateFromProps(nextProps: TooltipProps): {
        visible: boolean;
    };
    constructor(props: TooltipProps);
    render(): JSX.Element;
    getChildProps: () => {
        onClick: () => void;
        onFocus?: undefined;
        onBlur?: undefined;
        onMouseEnter?: undefined;
        onMouseLeave?: undefined;
    } | {
        onFocus: () => void;
        onBlur: () => void;
        onClick?: undefined;
        onMouseEnter?: undefined;
        onMouseLeave?: undefined;
    } | {
        onMouseEnter: () => void;
        onMouseLeave: () => void;
        onClick?: undefined;
        onFocus?: undefined;
        onBlur?: undefined;
    };
    getPosition: (contentEl: HTMLDivElement) => {
        left: number;
        top: number;
    };
    handleEnter: (el: any) => void;
    handleClick: () => void;
    handleFocus: () => void;
    handleBlur: () => void;
    handleMouseEnter: () => void;
    handleMouseLeave: () => void;
}
export default Tooltip;
