"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inheritsLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/inheritsLoose"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var React = _interopRequireWildcard(require("react"));

var _reactDom = require("react-dom");

var classNames = _interopRequireWildcard(require("classnames"));

var _reactTransitionGroup = require("react-transition-group");

var Tooltip =
/*#__PURE__*/
function (_React$PureComponent) {
  (0, _inheritsLoose2["default"])(Tooltip, _React$PureComponent);

  Tooltip.getDerivedStateFromProps = function getDerivedStateFromProps(nextProps) {
    if ('visible' in nextProps) {
      return {
        visible: nextProps.visible
      };
    }

    return null;
  };

  function Tooltip(props) {
    var _this;

    _this = _React$PureComponent.call(this, props) || this;
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "hoverTimer", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "childRef", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "contentRef", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "getChildProps", function () {
      var trigger = _this.props.trigger;

      switch (trigger) {
        case 'click':
          {
            return {
              onClick: _this.handleClick
            };
          }

        case 'focus':
          {
            return {
              onFocus: _this.handleFocus,
              onBlur: _this.handleBlur
            };
          }

        default:
          {
            return {
              onMouseEnter: _this.handleMouseEnter,
              onMouseLeave: _this.handleMouseLeave
            };
          }
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "getPosition", function (contentEl) {
      var placement = _this.props.placement;
      var el = (0, _reactDom.findDOMNode)((0, _assertThisInitialized2["default"])(_this));
      var left = 0;
      var top = 0;

      if (!(el instanceof Element)) {
        return {
          left: left,
          top: top
        };
      }

      var rect = el.getBoundingClientRect();
      var contentRect = contentEl.getBoundingClientRect();
      var scrollTop = document.documentElement.scrollTop || document.body.scrollTop;
      var scrollLeft = document.documentElement.scrollLeft || document.body.scrollLeft;

      switch (placement) {
        case 'top-start':
          left = scrollLeft + rect.left;
          top = scrollTop + rect.top - contentRect.height;
          break;

        case 'top':
          left = scrollLeft + rect.left + rect.width / 2 - contentRect.width / 2;
          top = scrollTop + rect.top - contentRect.height;
          break;

        case 'top-end':
          left = scrollLeft + rect.left + rect.width - contentRect.width;
          top = scrollTop + rect.top - contentRect.height;
          break;

        case 'right-start':
          left = scrollLeft + rect.right;
          top = scrollTop + rect.top;
          break;

        case 'right':
          left = scrollLeft + rect.right;
          top = scrollTop + rect.top + rect.height / 2 - contentRect.height / 2;
          break;

        case 'right-end':
          left = scrollLeft + rect.right;
          top = scrollTop + rect.bottom - contentRect.height;
          break;

        case 'bottom-start':
          left = scrollLeft + rect.left;
          top = scrollTop + rect.top + rect.height;
          break;

        case 'bottom':
          left = scrollLeft + rect.left + rect.width / 2 - contentRect.width / 2;
          top = scrollTop + rect.top + rect.height;
          break;

        case 'bottom-end':
          left = scrollLeft + rect.left + rect.width - contentRect.width;
          top = scrollTop + rect.top + rect.height;
          break;

        case 'left-start':
          left = scrollLeft + rect.left - contentRect.width;
          top = scrollTop + rect.top;
          break;

        case 'left':
          left = scrollLeft + rect.left - contentRect.width;
          top = scrollTop + rect.top + rect.height / 2 - contentRect.height / 2;
          break;

        case 'left-end':
          left = scrollLeft + rect.left - contentRect.width;
          top = scrollTop + rect.bottom - contentRect.height;
          break;

        default:
      }

      return {
        left: left,
        top: top
      };
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleEnter", function (el) {
      var position = _this.getPosition(el);

      _this.setState(position);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleClick", function () {
      var visible = _this.state.visible;

      _this.setState({
        visible: !visible
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleFocus", function () {
      _this.setState({
        visible: true
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleBlur", function () {
      _this.setState({
        visible: false
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleMouseEnter", function () {
      window.clearTimeout(_this.hoverTimer);
      _this.hoverTimer = window.setTimeout(function () {
        _this.setState({
          visible: true
        });
      }, 100);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleMouseLeave", function () {
      window.clearTimeout(_this.hoverTimer);
      _this.hoverTimer = window.setTimeout(function () {
        _this.setState({
          visible: false
        });
      }, 50);
    });
    _this.hoverTimer = 0;
    _this.contentRef = React.createRef();
    _this.childRef = React.createRef();
    _this.state = {
      visible: false,
      left: 0,
      top: 0
    };
    return _this;
  }

  var _proto = Tooltip.prototype;

  _proto.render = function render() {
    var _classNames;

    var _this$props = this.props,
        children = _this$props.children,
        prefixCls = _this$props.prefixCls,
        disabled = _this$props.disabled,
        content = _this$props.content,
        placement = _this$props.placement,
        trigger = _this$props.trigger,
        attributes = (0, _objectWithoutPropertiesLoose2["default"])(_this$props, ["children", "prefixCls", "disabled", "content", "placement", "trigger"]);
    var tooltopClassName = classNames((_classNames = {}, _classNames[prefixCls] = true, _classNames[prefixCls + "-" + placement] = true, _classNames));
    var _this$state = this.state,
        visible = _this$state.visible,
        left = _this$state.left,
        top = _this$state.top;
    var tooltipNode = React.createElement(_reactTransitionGroup.CSSTransition, {
      "in": visible,
      timeout: 150,
      unmountOnExit: true,
      onEnter: this.handleEnter,
      classNames: "" + prefixCls
    }, React.createElement("div", {
      className: tooltopClassName,
      style: {
        left: left,
        top: top
      },
      onMouseEnter: trigger === 'hover' ? this.handleMouseEnter : undefined,
      onMouseLeave: trigger === 'hover' ? this.handleMouseLeave : undefined
    }, React.createElement("div", {
      className: prefixCls + "-arrow"
    }), React.createElement("div", {
      className: prefixCls + "-inner"
    }, content)));
    var childProps = this.getChildProps();
    var childNode = React.createElement("span", (0, _extends2["default"])({
      className: prefixCls + "-reference"
    }, childProps, attributes), children);
    return React.createElement(React.Fragment, null, childNode, !disabled && (0, _reactDom.createPortal)(tooltipNode, document.body));
  };

  return Tooltip;
}(React.PureComponent);

(0, _defineProperty2["default"])(Tooltip, "defaultProps", {
  prefixCls: 'dk-tooltip',
  placement: 'top',
  trigger: 'hover'
});
var _default = Tooltip;
exports["default"] = _default;